(* Initialize buffer pointer symbol and sub-process id *)
KBF$LFShare=Null;
KBF$LFPid=Null;

KBF$LFKill[] := (If[RealQ[KBF$LFPid] && KBF$LFPid>0, Kill[KBF$LFPid]; Wait4[KBF$LFPid]];
  KBF$LFPid=Null);

KBF$ListFiles[pwd_,currfilter0_,wl_,fork_:False] := Module[
  {l={},f,currfilter=currfilter0,sl0,sl,c,lmode},
  Scan[(#[Cursor]="watch")&,wl];
  Update[IdleTasks];

  If[fork,
    KBF$LFKill[];		(* Initialize pid holder *)
    If[KBF$LFShare===Null,	(* Initialize shared memory object *)
      If[Not[RealQ[KBF$LFShareSize]]
	|| Not[KBF$LFShareSize > 1e3] || Not[KBF$LFShareSize < 10 * 1e6],
	KBF$LFShareSize=800*1000];
      KBF$LFShare=OpenShared[KBF$LFShareSize]];
    If[KBF$LFShare<=>$Failed,
      Shared[KBF$LFShare]=Null;	(* Initialize shared-memory contents *)
      KBF$LFPid=Fork[];
      If[RealQ[KBF$LFPid] && KBF$LFPid>0, Return[Null]]];
    ];
  If[currfilter=="",currfilter = "*"];
  Check[
    If[(f = OpenRead["!unset LANG LC_TIME;cd "//pwd//";ls -lntL"])<=>$Failed,
      l=Table[
        c=Read[f,Word];
        If[c===EndOfFile,Break[]];
        lmode=StringLength[c];
        c=c[1];
        If[c=="d" || c=="-",
          Skip[f,{If[lmode>11,3,4,4]*Word}];
          sl0=Read[f,{3*Word,String}];
	  (* Incomplete date field formatter [CAUTION: locale dependent] *)
	  sl = Switch[StringLength/@Take[sl0, 3],
	    {3, 1|2, 4}, (* msym, dd, ccyy *)
	    {sl0[[1]], ("  "//sl0[[2]])[-2,-1], " "//sl0[[3]]},

	    {3, 1|2, 5}, (* msym, dd, HH:MM *)
	    {sl0[[1]], ("  "//sl0[[2]])[-2,-1], sl0[[3]]},

	    {1|2, 3, 4}, (* dd, msym, ccyy *)
	    {sl0[[2]], ("  "//sl0[[1]])[-2,-1], " "//sl0[[3]]},

	    {1|2, 3, 5}, (* dd, msym, HH:MM *)
	    {sl0[[2]], ("  "//sl0[[1]])[-2,-1], sl0[[3]]},

	    _, (* otherwise [force align] *)

	    { ("   "//sl0[[1]])[-3,-1],
	      ("  "//sl0[[2]])[-2,-1],
	      ("     "//sl0[[3]])[-5,-1]}];

          If[c=="d" || currfilter=="*" || StringMatchQ[sl0[[4]],currfilter],
	    StringJoin[c,"   ",sl[[1]]," ",sl[[2]]," ",sl[[3]],
	      "   ",sl0[[4]]],
            Null[]],
          Skip[f,String];
          Null[]],
        {Infinity}];
      Close[f]
      ],];
  If[fork && KBF$LFPid===0,	(* KBF$LFPid === 0: KBF$LFShare is allocated && I'm worker *)
    ( Check[Shared[KBF$LFShare]=l, Shared[KBF$LFShare]={}];
      If[Library@Require["FFICall"],
	FFICall[DYNL$DEFAULT, "_exit", "void", {"int"}, 0],
	Execve["/bin/sh", {"sh", "-c", "exit 0"}, {}]]),
    Scan[(#[Cursor]="left_ptr")&, wl]; Return[l]];
  ];

KBF$WaitFileList[wl_,lb_]:=Module[{l,c=False,n=15},
  If[KBF$LFShare===$Failed || KBF$LFShare===Null, Return[{}]];
  Do[
    If[(l=Shared[KBF$LFShare])<=>Null,
      Scan[(#[Cursor]="left_ptr")&,wl];
      lb[Foreground]="black";
      If[RealQ[KBF$LFPid] && KBF$LFPid>0, Wait4[KBF$LFPid]]; KBF$LFPid=Null; 
      Return[l],
      lb[Delete]={2,"end"};
      lb[Insert]={2,StringFill[" Please wait ",".",n++]};
      lb[Foreground]=If[c=~c,"tomato","black"];
      TkSense[0.5]],
    {120}];
  Scan[(#[Cursor]="left_ptr")&,wl];
  KBF$LFKill[];
  {}];

KBF$$FileDialog=Class[{},{},
  {f,s,l,currdir,currfilter,pwd,r,currfullpath,dbflag,dirtmp,wf,fn,
   workflag,tsp0,tsp,ls,omtv,sc="#F44",ac="#F88",a,mbrecent,menurecent,brimage,
    recdir={},
   SortDate=1,SortDateRev=2,SortName=3,SortNameRev=4,btext,sortmethod=1,
   w,frr,frl,fr1,fr2,fr3,fr4,ldir,dirmenu,vsb,lb,lfilt,eflt,lsel,efile,bup,b,c,
   lc,frc,bapp,bsort,fr2a,fr2b,fr2ap1,fr2ap2,omt,omtm,lfile,ldate,kl,scol,
    bups1,bups2,savefile},

  changelist[f$_:"",b$_:True] := Module[{p},
    If [currfilter == "", currfilter = "*"];
    lb[Delete] = {1, "end"};
    lb[Insert] = {1, "Getting file list,"};
    Update[TkTasks];
    If[(l = KBF$ListFiles[pwd,currfilter,If[b$,{w,frr,frl},{}],True])===Null,
      l = KBF$WaitFileList[If[b$,{w,frr,frl},{}],lb]];
    lb[Delete] = {1,"end"};
    If[l<=>{}, With[{lt=sortls[l]},
      lb[Insert] = {1,lt};
      If[f$<=>"",
        p=Position[lt,_?(#[20,-1]==f$&),1,1];
        If[p<=>{},
          lb[Select$Set]=p;
          lb[YView]=Max[1,p-lb[Height]/2];
          lbsel[]]]],
      lb[Insert] = {1, " ---  Empty ---"}]
  ];

  dochangedirectory[s_String,n_] := Module[{i},
    If [Length[tsp] == n,
	  changelist[];
    ,!Else
      dirup[Length[tsp]-n];
    ];
  ];
    
  dirup[n_] := Module[
    {ups},

    If [n > 0,
      omtm[Delete]={Length[tsp]-n+2,Length[tsp]+1};
      tsp = Drop[tsp, -n];
      If [tsp == {},
        pwd = If[tsp0[-1]==="/", tsp0, tsp0//"/"];
        currdir = pwd;
      ,!Else
        currdir = tsp[[-1]];
        pwd = If[tsp0[-1]==="/", tsp0, tsp0//"/"];
        Scan[(pwd = pwd//#//"/")&, tsp];
      ];
      omtv = currdir;
      currfullpath = pwd;
      b[Text] = btext;
      If [fn==0, b[State] = "disabled"];
	  changelist[];
      ups = If [pwd == "/", "disabled", "normal"];
      bup[State] = ups; bups1[State] = ups; bups2[State] = ups; 
    ];
  ];

  okordown[n_] := Module[
    {s,sel,ups},

    Update[IdleTasks];
    If [lb[Size]>0 && (sel=lb[Selection]) <=> {},
      s = lb[GetText[sel[[1]]]];
      If [(s[1] == "-")||((fn==1)&&(n==1)),
        addrecent[pwd,savefile];
        If [fn==1,
          If [savefile<>"",
            If [System["[ -e "//pwd//savefile//" ]"]==0,
              If [KBFMessageBox["The file "//pwd//savefile//" already exists.\nDo you really want to overwrite the file ?",Bitmap->"warning",Items->{"Ok","Cancel"}]==1,TkReturn[savefile]];
            ,!Else
              TkReturn[savefile];
            ];
          ];
        ,!Else
          TkReturn[s];
        ];
      ,!Else
        If [s[1] == "d",
          currdir = s[20,-1];
          tsp = Append[tsp, currdir];
          pwd = pwd//currdir//"/";
          currfullpath = pwd;
          With[{a=tsp[[-1]],b=Length[tsp]},
            omtm[Add]={Button[Text->currdir,Command:>dochangedirectory[a,b]]}];
          omtv = currdir;
          b[Text] = btext;
          If [fn==0, b[State] = "disabled"];
		  changelist[];
          ups = "normal";
          bup[State] = ups; bups1[State] = ups; bups2[State] = ups; 
        ];
      ];
    ,!Else
      If [(fn==1)&&(savefile<>""),
        addrecent[pwd,savefile];
        If[System["[ -e "//pwd//savefile//" ]"]==0,
          If [KBFMessageBox["The file "//pwd//savefile//" already exists.\nDo you really want to overwrite the file ?",
            Bitmap->"warning",Items->{"Ok","Cancel"}]==1,TkReturn[savefile]];
          ,!Else
          TkReturn[savefile];
          ];
      ];
    ];
  ];

  updatelist[sm_] := 
    If [sortmethod <=> sm,
      With[{sortmethod},
        bsort[sortmethod][FG] = "black";
        bsort[sortmethod][ActiveForeground] = "black";];
      bsort[sm][FG] = sc;
      bsort[sm][ActiveForeground] = ac;
      Update[IdleTaksk];
      sortmethod = sm;
      lb[Delete] = {1, "end"};
      If [l<=>{}, lb[Insert] = {"end", sortls[l]}];
      b[Text] = btext;
      b[State] = "disabled";
    ];

  sortls[l$_] :=
    Switch[sortmethod,
      SortDate,
        l$,
      SortDateRev,
        Reverse[l$],
      SortName,
        Map[(#[-19,-1]//#[1,-20])&,Sort[Map[(#[20,-1]//#[1,19])&,l$]]],
      SortNameRev,
        Reverse[Map[(#[-19,-1]//#[1,-20])&,Sort[Map[(#[20,-1]//#[1,19])&,l$]]]]
    ];

  lbsel[] := Module[{s}, 
    If [dbflag == 0,
      If [lb[Size]>0, 
        b[State] = "normal";
        s = lb[GetText[lb[Selection][[1]]]];
        If [s[1] == "-",
          currfullpath = pwd//s[20,-1];
          savefile = s[20,-1];
          b[Text] = btext;
        ,!Else
          If [(s[1]=="d")&&(fn==0),
            currfullpath = pwd//s[20,-1]//"/";
            b[Text] = "Go Down";
          ];
        ];
      ,!Else
         If[fn==0,b[State] = "disabled"];
      ];
    ,!Else
      dbflag = 0;
    ];
  ];

  addrecent[dir_,file_]:=Module[{p=Position[recdir,dir,1,1]},
    If[p<=>{},
      p=p[[1,1]];
      If[p==1,
        recfile[dir]=file;
        Return[],
        recdir=Prepend[Drop[recdir,{p,p}],dir];
        menurecent[Delete]=p],
      recdir=Prepend[recdir,dir];
      If[Length[recdir]>32,
        recdir=Drop[recdir,-1];
        menurecent[Delete]=32]];
    recfile[dir]=file;
    menurecent[Insert]={1,Button[Text->dirname[dir],Command:>jumpto[dir,recfile[dir]]]}];

  recfile[_]="";

  dirname[dir_]:=Module[{l=StringLength[dir]},
    If[l<=40,
      dir,
      dir[1,12]//" ... "//dir[l-23,l]]];

  Constructor[fn0_,$opt___]:=Module[{dir=dir0},
    fn=fn0;
    btext = If[fn==0,"Open","Save"];

! creating dialog
    scol = {BG->"white",SelectBackground->"wheat",SelectForeground->"black",SelectBorderWidth->0};
    wf = KBDialogFrame["FileDialog", w, Title->"FileDialog"];
    If [w === Null, Return[Null]];
    frr = Frame[w, Side->"left", Fill->"both", PadX->10, PadY->5, Expand->1];
    fr1 = Frame[frr, PadX->7, PadY->2, Fill->"x"];
    ldir = TextLabel[fr1, Width->12, TextAnchor->"w", Text->"Directory : ",
      Side->"left"];
    omt = OptionMenu[fr1, TextVariable:>omtv, Side->"left", Relief->"ridge"
      ,BG->"gray85"];
    omtm = Menu[omt];
    fr2 = Frame[frr, Fill->"both", PadX->8, PadY->5, Expand->1];
    fr2a = Frame[fr2, Fill->"x", Relief->"sunken", BD->1, PadX->2];
    bups1 = Button[fr2a, Side->"left", IPadY->1, BD->1,
      Bitmap->"@"//KBF$ConfDir//"/dirup.xbm"];
    fr2ap1 = Frame[fr2a,Width->16,Side->"left"];
![               ,BD->1,Relief->"raised",Fill->"y",PadY->2];
    With[{SortDate,SortDateRev,SortName,SortNameRev},
      bsort[SortDate] = Button[fr2a,Side->"left",IPadY->1,BD->1,
        FG->sc,ActiveForeground->ac,
        Bitmap->"@"//KBF$ConfDir//"/downarrow.xbm"];
      ldate = TextLabel[fr2a,Text->"Date",Relief->"raised",Side->"left",BD->1,
        Font->TextFont[10,$DefaultSansSerifFont,"bold"],IPadX->5];
      bsort[SortDateRev] = Button[fr2a,Side->"left",IPadY->1,BD->1,
        Bitmap->"@"//KBF$ConfDir//"/uparrow.xbm"];
      fr2ap2 = Frame[fr2a,Width->26,Side->"left"];
      bsort[SortName] = Button[fr2a,Side->"left",IPadY->1,BD->1,
        Bitmap->"@"//KBF$ConfDir//"/downarrow.xbm"];
      lfile = TextLabel[fr2a,Text->"File",Relief->"raised",Side->"left",BD->1,
        Font->TextFont[10,$DefaultSansSerifFont,"bold"],IPadX->5];
      bsort[SortNameRev] = Button[fr2a,Side->"left",IPadY->1,BD->1,
        Bitmap->"@"//KBF$ConfDir//"/uparrow.xbm"];
      ];
    bups2 = Button[fr2a, Side->"right", IPadY->1, BD->1,
      Bitmap->"@"//KBF$ConfDir//"/dirup.xbm"];
    fr2b = Frame[fr2, Fill->"both", Expand->1];
    vsb=ScrollBar[fr2b, Orient->"vertical", Side->"right", Fill->"y",
      Width->12];
    lb=ListBox[fr2b, Insert->{"end",{"Getting file list....","  Please wait."}}, Height->(ListHeight/.Options/.ListHeight->24), BG->"white", Fill->"both",
      SelectMode->"single", Expand->1, YScrollCommand:>vsb[Set],
      Side->"right", Font->TextFont[12, $DefaultFixedFont],
      Width->(ListWidth/.Options/.ListWidth->50), scol];
    fr3 = Frame[frr, Fill->"x", PadX->7, PadY->2];
    lfilt = TextLabel[fr3, Width->12, TextAnchor->"w", Text->"Filter : ",
      Side->"left"];
    eflt = Entry[fr3, Side->"left", TextVariable:>currfilter, Fill->"x",
      Expand->1, scol];
    bapp = Button[fr3, Side->"right", Text->"Apply", Width->6, PadX->5,
      Font->TextFont[10,$DefaultSansSerifFont,"bold"]];
    fr4 = Frame[frr, Fill->"x", PadX->7, PadY->2];
    lsel = TextLabel[fr4, Width->12, TextAnchor->"w",Side->"left",
      Text->If[fn==0,"Selection : ","Save File : "]];
    efile = Entry[fr4, Width->35, Side->"left", Fill->"x", Expand->1,
      If[fn==0,{State->"disabled", Relief->"ridge", TextVariable:>currfullpath,BG->"gray85"},{BG->"white", TextVariable:>savefile}]];
    frl = Frame[w, Side->"right", PadX->5, PadY->5, Fill->"y"];
!    kl = PhotoImage["kekblogo",File->KBF$ConfDir//"/KEKBlogo2.gif",
!                      Format->"gif"];
!    lc = Canvas[frl, BD->2, Width->kl[Width]-4, Height->kl[Height]-4,
!                   Relief->"sunken", PadY->3];
!    lc[Create$Image]={0,0,Image->kl[Name],Anchor->"nw"};
    bup = Button[frl, Width->8, Text->"Up", Side->"top"];
    brimage=PhotoImage["kbfrec",File->KBF$ConfDir//"/KBF_Recent.gif",Format->"gif"];
    mbrecent=MenuButton[frl,Picture->"kbfrec",Side->"top",BD->0,PadY->10];
    menurecent=Menu[mbrecent];
    addrecent[Directory[]//"/",""];
    b = Button[frl, Width->8, Text->btext, Side->"bottom",
      State->If[fn==0,"disabled","normal"],
      Command:>okordown[1]];
    c = Button[frl, Width->8, Text->"Cancel", Side->"bottom",
      Command:>TkReturn[Null]];

!   AdjustWindowGeometry[w];

! set up widgets
    bapp[Command] := changelist[];
    bup[Command] := dirup[1];
    bups1[Command] := dirup[1];
    bups2[Command] := dirup[1];
    Do[With[{i},bsort[i][Command] := updatelist[i]],{i,1,4}];

! binding
    Bind[lb, "<ButtonRelease-1>", lbsel[]];
    Bind[lb, "<Double-Button-1>", (dbflag=1; okordown[0])];
    dbflag = 0;
    Bind[lb, "<Key-Return>", okordown[0]];
    Bind[eflt, "<Key-Return>", changelist[]];
    Bind[eflt, "<Double-Button-1>", changelist[]];
!  Bind[w, "<Key-Escape>", TkReturn[Null]];
    ];

  jumpto[dir_,file_:""]:=(
    pwd=dir;
    If [pwd[-1] <=> "/", pwd = pwd//"/";];
    currfullpath = pwd;
    currdir = If [pwd == "/", "/", pwd[StringPosition[pwd,"/"][[-2,1]]+1,-2]];
    savefile = "";
    wf[Normal];
    omtm[Delete]={1,"end"};
    If [pwd == "/",
      omtv = "/"; tsp0="/"; tsp = {};
      bup[State] = "disabled";
      bups1[State] = "disabled";
      bups2[State] = "disabled";
      omtm[Add]={Button[Text->"/", Command:>dochangedirectory["/",0]]}
      ,!Else
      tsp = pwd[#[[1]],#[[2]]]&/@(Transpose[{Drop[#,-1]+1,Drop[#,1]-1}]&[
        Transpose[StringPosition[pwd,"/"]][[1]]]);
      tsp0=With[{pos=StringPosition[pwd,"/"]}, 
	If[Length[pos]>0 && pos[[1,1]]>1, pwd[1, pos[[1,1]]-1], "/"]];
      omtm[Add]={Button[Text->tsp0, Command:>dochangedirectory[tsp0,0]]};
      omtv = tsp[[-1]];
      Do[With[{a=tsp[[i]],i},
        omtm[Add]={Button[Text->tsp[[i]], Command:>dochangedirectory[a,i]]}],
        {i,Length[tsp]}];
      bup[State] = "normal";
      bups1[State] = "normal";
      bups2[State] = "normal"
      ];
    changelist[file,False]);


  Dialog[dir0_String,files_String]:=Module[{r,dir},
    dir = If[dir0 === "", Directory[], RealPath[dir0]];
    dir = If[DirectoryQ[dir], dir, "/"];
    currfilter = files;
    jumpto[dir];
    Update[IdleTasks];
    r = TkWait[];!Print["1"];
    dirtmp = pwd;
    wf[Withdraw];
    Update[IdleTasks];
    If [r <=> Null, dirtmp//If[fn==0,r[20,-1],r], Null]]

  ];

KBF$FD[_]=Null;

KBFOpenDialog[dir_String,filter_String:"*",opts$___] := (
  If[KBF$FD[0]===Null,
    KBF$FD[0]=KBF$$FileDialog[0, opts$]];
  KBF$FD[0]@Dialog[dir, filter]);

KBFSaveDialog[dir_String,filter_String:"*",opts$___] := (
  If[KBF$FD[1]===Null,
    KBF$FD[1]=KBF$$FileDialog[1, opts$]];
  KBF$FD[1]@Dialog[dir, filter]);

Protect[KBFOpenDialog,KBFSaveDialog,KBF$$FileDialog,KBF$ListFiles];
