!! Frames for KEKB control software -- 
! Originally developed by N. Akasaka since 1997
!
!   V1.0.10.3.3a1 K. Oide, KBF$SAFilename to save the file name for SaveAs
!   V1.0.10.3a5 K. Oide, KBF$Convert to specify convert.
!   V1.0.10.3a4 K. Oide, Change default font size.
!!! V1.0.8.18.2b8 9/16/2003 K. Oide SpinBox option in KBFString & KBFNumber
!!! V1.0.8.18.1b2 9/10/2003 K. Oide "Make PDF" Menu, KBF$Dir to Keep Last Directory
!!! V1.0.8.12.4b 1/14/2002 K. Oide
!   (1) Start/stop QuickWindow was removed.
!   (2) OptionDialog and MessageBox were separated.
!!! V1.0.8.9.8b1 8/1/2001 K. Oide
!   (1) a[Withdraw] and a[Normal] were added (may be a bad idea?)
!!! V1.0.8.9.8b 7/31/2001 K. Oide
!   (1) FileDialog and TabFrame were separated. FileDialog has become a Class.
!!! V1.0.8.9b 4/24/2001 K. Oide
!   (1) The Hard Copy Button creates the gif file when Shift is pressed.
!!! V1.0.8.8.4b 3/1/2001 Modified by K. Oide
!   (1) Pads are reduced to have more real estate.
!   (2) Remove With as a result of change in Tkinter.

KBF::main="KBMainFrame can be called only once";
KBF::mainfirst="KBMainFrame must be called first";
KBF::dupsub="Duplicated subframes";

KBF$DefaultLauncher = "/usr/local/bin/kbl";
KBF$DefaultLauncherName = "KBTaskLaunch";
KBF$DefaultSAD = "/SAD/bin/gs";

KBF$Which[cmd_String] := With[{fp = OpenRead["!which "//EscapeShellMetaCharacter[cmd]]},
  If[RealQ[fp], With[{r = Read[fp, String]}, Switch[(Close[fp]; r),
    "",		Null,
    _String,	r,
    _,		Null]], Null]];

Scan[With[{
  sym = Switch[Unevaluated$[#],
    _Rule,	Extract[Unevaluated$[#], {1}, Unevaluated$],
    _,		Unevaluated$[#]],
  default = Switch[Unevaluated$[#],
    _Rule,	Extract[Unevaluated$[#], {2}],
    _,		Null]},
  With[{orig = sym},
    Clear[sym];
    (sym := Null);
    (sym  = cmd_) ^:= With[{prev = sym}, Switch[cmd,
      _String,	With[{path = KBF$Which[cmd]}, Switch[path,
	_String,sym := path; prev,
	_,		     prev]],
      _,	sym := Null; prev]];

    If[(sym = orig; sym === Null) && default <=> Null,
      Scan[If[(sym = #; sym <=> Null), Break[]]&, Flatten[{default}]]]]]&, Unevaluated$[{
	KBF$convert->{If[StringQ[KBF$Convert], KBF$Convert, Null[]], "convert"},
	KBF$xwd->"xwd",
	KBF$xwud->"xwud",
	KBF$xcalc->{"xhpcalc", "xcalc"}}]];		(* Don't insert Null[] *)

(* Backword compatible tunable *)
Clear[KBF$Convert];
(KBF$Convert := KBF$convert);
(KBF$Convert = cmd_) ^:= (KBF$convert = cmd);

If[Length[(Hold@@[?ReturnToSAD,{1}])[[1]]]==1 && ReturnToSAD<=>True,
  ReturnToSAD=False];

KBF$SAFilename="";
KBFrame$Names0 = Names["*"];
KBF$State[b_] := If[b, "normal", "disabled", "disabled"];
KBF$SAD := If[#<=>"", #, KBF$DefaultSAD]&[Environment["SAD"]];
KBF$ConfDir = With[{dir = Environment["KBFRAMEDIR"]},
  If[dir <=> "", dir, "/SAD/share/KBFrame"]];
KBF$FontResouceFile[tag_String, type_String] := StringJoin[KBF$ConfDir, "/",
  "KBFrameFont-", tag, "-", type, ".res"];
KBF$ResourceFiles[tag_String] := {
  KBF$ConfDir//"/KBFrameColor.res",			(* color resource *)
  If[FileQ[KBF$FontResouceFile[tag, $FontSystem]],	(* font  resource *)
    KBF$FontResouceFile[tag, $FontSystem],
    KBF$FontResouceFile[tag, "X11"]],
  Null[]};

If[~StringQ[KBF$Launcher], KBF$Launcher := KBF$DefaultLauncher];
If[~StringQ[KBF$LauncherName], KBF$LauncherName := KBF$DefaultLauncherName];
(KBF$Launcher = val_) ^:= With[{s = If[StringQ[val], val,
  KBF$DefaultLauncher]}, KBF$Launcher := s];
(KBF$LauncherName = val_) ^:= With[{If[StringQ[val], val,
  KBF$DefaultLauncherName]}, KBF$LauncherName := s];

(* If KBF$X11Options$Enable is True, KBF$X11Options is applyed KBMainFrame *)
If[Not[RealQ[KBF$X11Options$Enable]], KBF$X11Options$Enable = True];
Module[{argp, argv = $GetCommandLine[]}, (* Parse command line options *)
  KBF$X11Options = {};
  argp = -Length[argv]; While[argp < 0, Switch[argv[[argp]],
    "-geometry", (* geometry option *)
    If[argp < -1, argp += 1;
      AppendTo[KBF$X11Options, Geometry->argv[[argp]]]],

    "-c", argp += 1, (* Skip sad interpreter option *)
    _, (* Skip unkown option *)];
    argp += 1]];

(a_ = KBMainFrame[an_String, f_, opt___]) ^:= (
  a = KB$Frame[an, f, {$Main->True,$Dialog->False}, opt];
  If[KBF$X11Options$Enable, Scan[(a[#[[1]]] = #[[2]])&, KBF$X11Options]];
);

(a_ = KBSubFrame[an_String, f_, opt___]) ^:= (
  a = KB$Frame[an, f, {$Main->False,$Dialog->False}, opt, HardCopyName->an];
);

(a_ = KBDialogFrame[an_String, f_, opt___]) ^:= (
  a = KB$Frame[an, f, {$Main->False,$Dialog->True}, opt, HardCopyName->an];
);

(a_ = KB$Frame[an_String, f_, fopt_List, opt___]) ^:= Module[{{bm,wm,em,mb,defres,hc$name}=SwitchCases[Override[opt],{Rule[Main,_],Rule[WindowMenu,_],Rule[EditMenu,_],Rule[MenuBar,_],Rule[OptionFile,_],Rule[HardCopyName,_String]}],cwid,apnms},

  If[ ($Main/.fopt) && StringQ[KBF$AppName],
    If[a<=>KBF$Window,a=KBF$Window];
    If[f<=>KBF$Frame,f=KBF$Frame];
    Message[KBF::main];
    Return[]
    ];
  a=.;
  a[$IsMain] = $Main/.fopt;
  a[$IsDialog] = $Dialog/.fopt;
  mb = MenuBar/.mb/.(MenuBar->True);
  If [a[$IsMain],
    KBF$Window=a;
    KBF$Frame=f;
    KBF$AppBaseName = an;
    apnms = AppNames[];
    If [MemberQ[apnms,KBF$AppBaseName],
      Send[KBF$AppBaseName,KBFRaise[]];
      Exit[];
    ];
    KBF$AboutMessage = 
      "KBFrame (Blank)\nAuthor: N. Akasaka\nSep. 20 1997";
    KBF$ConfigTime = KBF$InfoLabelAfterID = 
    KBF$SADTerminal = Null;
    KBF$Dialog = KBF$PSList = {};
    KBF$Dir=Directory[];
    KBF$WMFlag = 1;
    KBF$IsInfoLabelCreated = KBF$IsInfoLabelMapped = False;
    KBF$OptionFileName[Medium]=KBF$ResourceFiles["Medium"];
    KBF$OptionFileName[Small]=KBF$ResourceFiles["Small"];
    KBF$OptionFileName[x_String]=x;
    KBF$OptionFileName[_]=KBF$OptionFileName[Medium];
    KBF$DefaultFontSize=Switch[$FontSystem,"Xft",12,_,14];

    KBF$ABG=Tkinter$BG[];
    KBF$BGColor="#e8e8e8";
    KBF$LabelBGColor = KBF$BGColor;
    KBF$MenuBGColor = "white";
    TkOptionAdd["*activeBackground",KBF$ABG];
!    KCF$i=0;

    KBF$CPUTime0 = TimeUsed[];
    KBF$StartTime = FromDate[];

  ,!Else
    If [KBF$AppName===Null,
      Message[KBF::mainfirst];
      f = Null;
      Return[];
    ];
    a[$Frame$Name] = an;
    If [a[$IsDialog],

    ,!Else
      Scan[
        If[an==#[$Frame$Name],
          Message[KBF::dupsub];
          f = Null;
          Return[];
        ]&
      ,!List
        KBF$FrameList
      ];
    ];
  ];

! Create Main Window.

  a[$Window] = Window[,opt];
  BindWidget[a[$Window], "<Reparent>", KBF$ReparentCB[a], Add->True];
  BindWidget[a[$Window], "<Map>", KBF$MapCB[a], Add->True];
  BindWidget[a[$Window], "<Configure>", KBF$ConfigureCB[]];
!  KBF$Window = Window[opt];
  a[$Frame$WindowID] = WidgetInformation[a[$Window], ID];
  a[$Frame$ShellID] = FindShellID[a[$Frame$WindowID]];
!Print[{"shell",a[$Frame$WindowID],a[$Frame$ShellID]}];
  KBF$Symbol[a[$Frame$WindowID]] := a;
  a[HardCopyName] = If[hc$name <=> {}, hc$name[[1, 2]], Null];
  a[HardCopyNameSpace] := KBF$HardCopyNameSpace[a];
  a[$HC$File$Path] = "/";
  If[a[$IsMain],
    KBF$AppName = ApplicationName[KBF$AppBaseName];
    If[SwitchCases[{opt}, {Rule[Title, _]}] === {{}},
      a[$Window][Title] = KBF$AppName];
    a[$Window][Protocol] := {"WM_DELETE_WINDOW", KBF$AppExit[]};
    If [MemberQ[apnms,KBF$LauncherName]&&(KBF$AppName<=>KBF$LauncherName),
      With[{an=KBF$AppName},
        Send[KBF$LauncherName, AppStartNotify[an]];
      ];
    ];
    a[$Frame$Name] = KBF$AppName;
    With[{opt$fn = KBF$OptionFileName[OptionFile/.defres/.OptionFile->Medium]},
      Switch[opt$fn,
	{__String},	Scan[TclEval["option readfile "//#]&, opt$fn],
	_String,	TclEval["option readfile "//opt$fn]]];
    KBF$Screen = WidgetInformation[a[$Window], Screen];
    KBF$FrameList = {a};
    If [(cwid=Environment["WINDOWID"])<>"",
      KBF$Console = FindShellID[ToExpression[cwid]];
    ,!Else
      KBF$Console = Null;
    ];
  ,!Else
    a[$Window][Protocol] := {"WM_DELETE_WINDOW", a[Close]};
    If [a[$IsDialog],
!	  a[$Window][Geometry] = ToGeometry[{,,Max[WidgetInfo[a[$Window],PointerX]-100,0],Max[WidgetInfo[a[$Window],PointerY]-50,0]}];
      PrependTo[KBF$Dialog, {a,a[$Frame$Name]}];
    ,!Else
      AppendTo[KBF$FrameList, a];
    ];
  ];
  a[CloseCommand] = Null;

! Create Menus

  a[$PrinterImage] = PhotoImage["printerlogo",File->KBF$ConfDir//"/print.gif",Format->"gif"];
  a[$PrinterImage2] = PhotoImage["printerlogo2",File->KBF$ConfDir//"/print2.gif",Format->"gif"];
  If [(~a[$IsDialog])&&mb,
    a[$Frame$Menu] = Frame[a[$Window], Fill->"x", BG->KBF$MenuBGColor, Relief->"flat", BD->0, IPadY->0];

    a[$PhotoImage] = PhotoImage["kekblogo4",File->KBF$ConfDir//"/KEKBlogo4.gif",Format->"gif"];
    a[$MenuButton$KEK] = MenuButton[a[$Frame$Menu], (*Bitmap->"@"//KBF$ConfDir//"/bb.xbm"*)Picture->"kekblogo4", Side->"left", BD->0, PadX->5(*, BG->"greenyellow"*)];
    a[$Menu$KEK] = Menu[a[$MenuButton$KEK], Add->With[{appn = KBF$AppName}, {
      Button[Text->"About "//appn//"...",Underline->0,Command:>KBF$AboutBox[]],
      Separator[],
      Button[Text->"Tasks...", Underline->0, Command:>KBF$StartLauncher[],
	State->KBF$State[appn <=> KBF$LauncherName]],
      Button[Text->"SAD Inspect", Underline->4, Command:>KBF$StartSADInspect[],
	State->KBF$State[appn <=> "SADInspect"]],
      Button[Text->"Printers...", Underline->0, Command:>KBF$PrinterChooser[]],
      Button[Text->"Hard Copy Other Window", Underline->0,
	Command:>KBF$HardCopy[a,False]],
      Button[Text->"Calculator", Underline->0, Command:>KBF$Calculator[]],
      Button[Text->"Lower", Underline->0, Command:>a[$Window][Lower]]}]];

    a[$MenuButton$File] = MenuButton[a[$Frame$Menu], Text->"File", Underline->0, Side->"left", PadX->1];
    a[$Menu$File] = Menu[a[$MenuButton$File], Add->{
      Button[Text->"New",	    Underline->0, State->"disabled"],
      Button[Text->"Open...",	    Underline->0, State->"disabled"],
      Button[Text->"Save",	    Underline->0, State->"disabled", Command:>a[SaveCommand]],
      Button[Text->"Save As...",    Underline->5, State->"disabled", Command:>a[SaveAsCommand]],
      Separator[],
      Button[Text->"Page Setup...", Underline->0,		     Command:>KBF$PageSetup[a]],
      Button[Text->"Hard Copy",	    Underline->0,		     Command:>KBF$HardCopy[a]],
      Button[Text->"Make PDF",	    Underline->0,		     Command:>KBF$MakePDF[a]],
      Separator[],
      If[a[$IsMain], Null[],
	Button[Text->"Close",	    Underline->0, State->"disabled", Command:>a[Close]]],
      Button[Text->"Exit",	    Underline->1,		     Command:>a[Exit]],
      Null[]}];

	If [EditMenu/.em/.(EditMenu->True),
	  a[$MenuButton$Edit] = MenuButton[a[$Frame$Menu], Text->"Edit", Underline->0, Side->"left", PadX->1];
	  a[$Menu$Edit] = Menu[a[$MenuButton$Edit]];
	  a[$Menu$Edit$Copy] = Menu[a[$Menu$Edit]];
	  a[$Menu$Edit][Add] = {Cascade[Text->"Copy", Underline->0, Menu->a[$Menu$Edit$Copy], State->"disabled"], Button[Text->"Paste", Underline->0, State->"disabled"],Separator[],Button[Text->"Option...",Underline->0,State->"disabled"]};
	];

    a[$Frame$UserMenu] = Frame[a[$Frame$Menu], BG->KBF$MenuBGColor, Relief->"flat", BD->0, IPadY->0, Side->"left"];

	If [WindowMenu/.wm/.(WindowMenu->True),
	  a[$MenuButton$Window] = MenuButton[a[$Frame$Menu], Text->"Window", Underline->0, Side->"left", PadX->1];
	  a[$Menu$Window] = Menu[a[$MenuButton$Window], PostCommand:>KBF$MakeWindowMenu[a]];
	];

    a[$MenuButton$Task] = MenuButton[a[$Frame$Menu], Bitmap->"@"//KBF$ConfDir//"/downarrow.xbm", Side->"right", PadX->2, IPadX->2, IPadY->2, ActiveForeground->"black", ActiveBackground->KBF$MenuBGColor];
  a[$Menu$Task] = Menu[a[$MenuButton$Task], PostCommand:>KBF$MakeTaskMenu[a]];

    a[$MenuButton$Help] = MenuButton[a[$Frame$Menu], Text->"Help", Underline->0, Side->"right"];
    a[$Menu$Help] = Menu[a[$MenuButton$Help], Add->{Button[Text->"Help", Underline->0, State->"disabled"], Separator[],Button[Text->"Process Information...",Underline->0,Command:>KBF$ProcessInfo[]],Button[Text->"SAD Information...",Underline->0,Command:>KBF$SADVersionInfo[]],Button[Text->"About "//KBF$AppName//"...", Underline->0, Command:>KBF$AboutBox[]]}];
  ];

! Close/Exit button handler
  a[Close] := a[$Close]; a[$Close] := KBF$WindowClose[a];
  (a[Close] := state_:("normal"|"disable")) ^:= If[Not[a[$IsMain]],
    a[$Menu$File][EntryConfigure] = {"Close", State->state}];
  (a[Close] = state_:("normal"|"disable")) ^:= If[Not[a[$IsMain]],
    a[$Menu$File][EntryConfigure] = {"Close", State->state}];
  (a[Close] := None) ^:= (a[$Close] := KBF$WindowClose[a]);
  (a[Close] := fun_) ^:= (a[$Close] := fun);

  a[Exit] := a[$Exit]; a[$Exit] := KBF$AppExit[];
  (a[Exit] := state_:("normal"|"disable")) ^:= (
    a[$Menu$File][EntryConfigure] = {"Exit", State->state});
  (a[Exit] = state_:("normal"|"disable")) ^:= (
    a[$Menu$File][EntryConfigure] = {"Exit", State->state});
  (a[Exit] := None) ^:= (a[$Exit] := KBF$AppExit[]);
  (a[Exit] := fun_) ^:= (a[$Exit] := fun);

! User Area

  f = Frame[a[$Window], Fill->"both", 
    If[~a[$IsDialog],{Width->400, Height->300},Null[]], 
      Expand->True, Relief->"sunken", BD->1];
  If [a[$IsDialog], Bind[f,"<Map>",KBF$DialogGeometry[a,f]]];

! Status Line

  a[$Frame$Stat] = Frame[a[$Window], Fill->"x"];
  a[$Label$Stat] = TextLabel[a[$Frame$Stat], TextAnchor->"w", Side->If[a[$IsDialog],"right","left"], Text->"Status", FG->"darkgreen", Expand->True, Fill->"x", Relief->"sunken", BD->1, BG->KBF$LabelBGColor];
  a[$Label$Print] = TextLabel[a[$Frame$Stat], Picture->"printerlogo",Side->"left", Fill->"y", BD->1, Relief->"sunken"];
  Bind[a[$Label$Print],"<Control-ButtonRelease>",KBF$HardCopy[a,True,Print],Break->True];
  Bind[a[$Label$Print],"<Shift-ButtonRelease>",KBF$HardCopy[a,True,False],Break->True];
  Bind[a[$Label$Print],"<ButtonRelease>",KBF$HardCopy[a],Break->True];
  If [~a[$IsDialog],
    a[$Frame$Prog] = Frame[a[$Frame$Stat], Side->"left", BG->KBF$LabelBGColor, Fill->"y",BD->1, Relief->"sunken"];
     a[$Frame$ProgBar1] = Frame[a[$Frame$Prog],Side->"left",Width->50,BG->KBF$LabelBGColor,Fill->"y"];
     a[$Frame$ProgNum1] = TextLabel[a[$Frame$ProgBar1],GM->Place,X->50,RelY->0.5,Anchor->"center",BG->KBF$LabelBGColor,FG->KBF$LabelBGColor];
     a[$Frame$ProgBar2] = Frame[a[$Frame$Prog],Side->"right",Width->50,BG->KBF$LabelBGColor,Fill->"y"];
     a[$Frame$ProgNum2] = TextLabel[a[$Frame$ProgBar2],GM->Place,X->0,RelY->0.5,Anchor->"center",BG->KBF$LabelBGColor,FG->KBF$LabelBGColor];
    If [mb,
      a[$Label$Time] = TextLabel[a[$Frame$Menu], Side->"right", Text->DateString[Format->"ISOs"], FG->"slateblue", Relief->"flat", BD->0, Width->20, BG->KBF$MenuBGColor, Font->TextFont[$DefaultSerifFont,"bold",KBF$DefaultFontSize]];
      ];
  ];

  a[$State]="normal";
  If[a[$IsDialog],
    KBF$WindowClose[a] := (
      a[CloseCommand];
      KBF$Dialog[[1,1]][$Window][Grab$Release];
      KBF$Dialog = Rest[KBF$Dialog];
      If [Length[KBF$Dialog]>0, KBF$Dialog[[1,1]][$Window][Grab$Set]];
      a[$Window]=.;
      KBF$Symbol[a[$Frame$WindowID]] =.;
      KBF$WindowClose[a]=.;
      Clear[a]
      );
    a[Withdraw] := (
      KBF$Dialog[[1,1]][$Window][Grab$Release];
      KBF$Dialog = Rest[KBF$Dialog];
      If [Length[KBF$Dialog]>0, KBF$Dialog[[1,1]][$Window][Grab$Set]];
      a[$State]:="withdrawn";
      a[State]="withdrawn");
    a[Normal] := If[a[$State]<=>"normal",
      a[$State]:="normal";
      a[State]="normal";
      If[Length[KBF$Dialog]>0,KBF$Dialog[[1,1]][$Window][Grab$Release]];
      PrependTo[KBF$Dialog, {a,a[$Frame$Name]}];
      a[$Window][Grab$Set]];
    KBF$QuickWindow[a];
    Return[]];

  If[a[$IsMain], KBF$WindowClose[a] := KBF$AppExit[], KBF$WindowClose[a] := (
    a[CloseCommand];
    a[KBF$ClockStop];
    KBF$FrameList = DeleteCases[KBF$FrameList, a];
    a[$Window]=.;
    KBF$Symbol[a[$Frame$WindowID]] =.;
    KBF$WindowClose[a] =.;
    Clear[a]
    )];

  a[Withdraw] := (
    a[KBF$ClockStop];
    a[$State]:="withdrawn";
    a[State]="withdrawn");

  a[Normal] := If[a[$State]<=>"normal",
    a[$State]:="normal";
    a[State]="normal";
    a[KBF$ClockStop];
    a[KBF$ClockUpdate]];

  If [mb,
    a[KBF$ClockStop] := If[a[KBF$TimeAfterID] <=> Null,
      AfterCancel[a[KBF$TimeAfterID]]; a[KBF$TimeAfterID] = Null];
    a[KBF$ClockUpdate] := (
      a[KBF$TimeAfterID] = After[1, a[$Label$Time][Text] = DateString[Format->"ISOs"]; a[KBF$ClockUpdate]]);
    a[KBF$ClockUpdate];
  ];

! Define Functions Available to Users.

  (a[ProgressBar]=p_)^:=Block[{pc,pct},
    If[p===Null,
      a[$Frame$Prog][BG] = KBF$LabelBGColor;
      a[$Frame$ProgBar1][BG] = KBF$LabelBGColor;
      a[$Frame$ProgBar2][BG] = KBF$LabelBGColor;
      a[$Frame$ProgNum1][BG] = KBF$LabelBGColor;
      a[$Frame$ProgNum2][BG] = KBF$LabelBGColor;
      a[$Frame$ProgNum1][FG] = KBF$LabelBGColor;
      a[$Frame$ProgNum2][FG] = KBF$LabelBGColor;
    ,!Else
      If[a[$Frame$ProgPercent]===Null,
        a[$Frame$Prog][BG] = "white";
        a[$Frame$ProgBar1][BG] = "coral";
        a[$Frame$ProgBar2][BG] = "white";
        a[$Frame$ProgNum1][BG] = "coral";
        a[$Frame$ProgNum2][BG] = "white";
        a[$Frame$ProgNum1][FG] = "white";
        a[$Frame$ProgNum2][FG] = "coral";
      ];
      pc=Restrict[Round[p*100],0,100];
      pct = StandardForm[pc//"%"];
      a[$Frame$ProgNum1][Text] = pct;
      a[$Frame$ProgNum2][Text] = pct;
      pc = Restrict[pc,1,99];
      a[$Frame$ProgBar1][Width] = pc;
      a[$Frame$ProgBar2][Width] = 100 - pc;
      a[$Frame$ProgNum2][X] = 50 - pc;
    ];
    a[$Frame$ProgPercent]=p
  ];
  a[$Frame$ProgPercent] = Null;

  (a[ApplicationName]=an$_String)^:=(
	KBF$AppBaseName = an$;
	KBF$AppName = ApplicationName[KBF$AppBaseName];
	a[$Frame$Name] = KBF$AppName
  );

  (a[ApplicationRename]=an$_String)^:=With[{apnms = AppNames[]},
    If[KBF$AppBaseName <=> an$,
      KBF$AppBaseName = an$;
      If[MemberQ[apnms, KBF$AppBaseName],
	Send[KBF$AppBaseName, KBFRaise[]]; Exit[]];
      If[MemberQ[apnms, KBF$LauncherName] && KBF$AppName <=> KBF$LauncherName,
	With[{ap = KBF$AppName}, Send[KBF$LauncherName, AppStopNotify[ap]]]];
      KBF$AppName = ApplicationName[KBF$AppBaseName];
      If[MemberQ[apnms, KBF$LauncherName] && KBF$AppName <=> KBF$LauncherName,
	With[{ap = KBF$AppName}, Send[KBF$LauncherName, AppStartNotify[ap]]]];
      a[$Frame$Name] = KBF$AppName;
      ]];

  (a[StatusLine]={w$_,s$_String,opt$___})^:=
    Bind[w$, "<Enter>", If[Not[a[$Frame$StatusLock]],a[$Label$Stat][Text]=s$],opt$];
  (a[StatusLine]=s$_String)^:=With[{t0 = FromDate[Tick->0]},
    a[$Frame$StatusText] = s$;
    a[$Frame$StatusTime] = t0;
    a[$Label$Stat][Text] = s$; a[$Frame$StatusLock] = True];
  (a[StatusLine]={s$_String, dt$_Real})^:=With[{t0 = FromDate[Tick->0]},
    a[$Frame$StatusText] = s$;
    a[$Frame$StatusTime] = t0;
    If[dt$ > 0,
      After[dt$, If[a[$Frame$StatusLock] && a[$Frame$StatusTime] == t0, a[$Frame$StatusLock] = 0]]];
    a[$Label$Stat][Text] = s$; a[$Frame$StatusLock] = (dt$ > 0)];
  a[FreeStatusLine] := (a[$Frame$StatusLock] = False);
  a[$Frame$StatusText] = "";
  a[$Frame$StatusLock] = False;
  a[$Frame$StatusTime] = 0;

  (a[InfoLabel]={w$_,s$_String,opt$___})^:=(
    Bind[w$, "<Motion>", KBF$MoveCBForInfoLabel[s$],opt$];
    Bind[w$, "<Leave>", Bind[w$,"<Motion>"];KBF$WithdrawInfoLabel[False],opt$];
  );

  (a[MenuEntryConfigure] = {me$_,opts___})^:=(
     Switch[me$
     ,"New"|"Open..."|"Save"|"Save As..."|"Close",
       a[$Menu$File][EntryConfigure] = {me$,opts};
     ,"Option...",
       a[$Menu$Edit][EntryConfigure] = {me$,opts};
    ];
  );

  (a[RegisterCopy]={t$_,Command:>c$_}) ^:= (
    a[$Copy$list] = Append[a[$Copy$list],t$];
    a[$Menu$Edit][EntryConfigure] = {"Copy",State->"normal"};
    a[$Menu$Edit$Copy][Add] = {Button[Text->t$,Command:>KBF$DoCopy[a,c$],Stete->"normal"]};
  );

  (a[RegisterOption] := c$_) ^:= (
    a[$Menu$Edit][EntryConfigure] = {"Option...",State->"normal"};
    a[$Menu$Edit][EntryConfigure] = {"Option...",Command:>c$};
  );

  (a[m_:(RegisterOpen|RegisterOpenFilename)]={dir_,fil_,c$_}) ^:= (
    a[OpenCommand] = c$;
    a[$Menu$File][EntryConfigure] = {"Open...",State->"normal"};
    a[$Menu$File][EntryConfigure] = {"Open...",Command:>KBF$Open[dir,fil,c$,If[m===RegisterOpen,True,False]]};
  );

  (a[RegisterSaveAs]={dir_,fil_,c$_}) ^:= (
    a[SaveAsCommand] = c$;
    a[$Menu$File][EntryConfigure] = {"Save As...",State->"normal"};
    a[$Menu$File][EntryConfigure] = {"Save As...",Command:>KBF$SaveAs[dir,fil,c$]};
  );

  (a[RegisterSave] := c$_) ^:= (
    a[SaveCommand] := c$;
    a[$Menu$File][EntryConfigure] = {"Save",State->"normal"};
  );

  (a[AddMenuButton]={mb$_,opts___})^:=
    mb$ = MenuButton[a[$Frame$UserMenu], Side->"left", PadX->1, opts];

  (a[AboutMessage]=s$_String)^:=
    KBF$AboutMessage = s$;

  (* Backword compatible SIM *)
  a[HardCopyScale]:=KBF$GetHardCopyConfig[a[HardCopyNameSpace], "Scale"];
  (a[HardCopyScale]=r$_)^:=KBF$SetHardCopyConfigList[a[HardCopyNameSpace], "Scale"->r$];
  a[$HC$Scale]:=Append[
    KBF$GetHardCopyConfig[a[HardCopyNameSpace],
      {"LeftMargin", "RightMargin", "TopMargin", "BottomMargin", "Scale", "Orientation"}],
    KBF$GetHardCopyConfig[a[HardCopyNameSpace], {"Copies", "TransparencyCopies"}]]/.{
      t_String:>Switch[t[1],"l"|"L",2,_,1],Null->0};
  (a[$HC$Scale]=l$_)^:=KBF$SetHardCopyConfig[a[HardCopyNameSpace], l$];

  (a[ExitCommand] := c$_)^:=(KBF$ExitCommand[]:=c$);

  ! initial setting of the status line

  a[StatusLine] = KBF$AppName//" on "//KBF$Screen;
  a[FreeStatusLine];
  a[StatusLine] = {f, "Main Application Area"};
  a[StatusLine] = {a[$Frame$Menu], "Menu Bar"};
  a[StatusLine] = {a[$Frame$Prog], "Progress Bar"};
  a[StatusLine] = {a[$Label$Stat], "Status Display"};
  a[StatusLine] = {a[$Label$Time], "Heart Beat (Tick Tock ....)"};
  a[StatusLine] = {a[$Label$Print], "Hard Copy"};

  KBF$QuickWindow[a];
];

KBF$QuickWindow[a_] := With[{k=Join[Options[Window],Actions[Window]]},
  (a[x$:k] = y$_) ^:= (a[$Window][x$] = y$);
  a[x$:k] := a[$Window][x$];
  a[(x$:k)[v$__]] := a[$Window][x$[v$]];
  a[CGet[v$__]] := a[$Window][CGet[v$]]
  ];
!KBF$StopQuickWindow[a_] := (
!  a/:(a[x$_] = y$_) =.;
!  a[x$_] =.;
!  );

KBF$DialogGeometry[w$_,f$_] := Module[{nx,ny,
  {w,h,x,y} = WidgetGeometry[w$[$Window]],
  {sw,sh,px,py} = WidgetInfo[w$[$Window],{ScreenWidth,ScreenHeight,PointerX,PointerY}]},
  Bind[f$,"<Map>",];
!  Print[{sw,sh,px,py}];
(*  nx = Floor[px-w/2];
    ny = Floor[py-h/2];
  If [nx<0, nx = 0];
  If [nx+w>sw, nx = sw - w];
  If [ny<0, ny = 0];
  If [ny+h>sh, ny = sh - h ]; *)
  {nx,ny}=Floor[{px,py}+50];    (*K. Oide 12/14/2000*)
  nx=Restrict[nx,0,sw-w];
  ny=Restrict[ny,0,sh-h];
  w$[$Window][Geometry] = ToGeometry[{,,nx,ny}];
!  w$[$Window][Geometry] = ToGeometry[{w,h,nx,ny}];
!  w$[$Window][Geometry] = ToGeometry[{,,Max[WidgetInfo[w$[$Window],PointerX]-100,0],Max[WidgetInfo[w$[$Window],PointerY]-50,0]}];
];

KBF$AboutBox[] := Module[{ifs,m,form},
  KBFMessageBox[KBF$AboutMessage,Title->"About "//KBF$AppName,Justify->"center"];
];

KBF$ProcessInfo[] := Module[{ifs,m},
  StandardForm[
!    ifs = OpenRead["!ps -p "//GetPID[]//" -o user,pcpu,nice,cputime,etime"];
    ifs = OpenRead["!ps -p "//GetPID[]//" -o user,pcpu,nice"];
    Read[ifs,String];
    m = "Host    :  "//KBF$HostName[];
    m = m//"\nUser    :  "//Read[ifs,Word];
    m = m//"\nPID     :  "//GetPID[];
    $FORM = "S10.1";
    m = m//"\nCPU     :  "//TimeUsed[]//" sec";
    $FORM = "F5.1";
    m = m//"\n%CPU    :  "//Read[ifs,Word]//" %";
    m = m//("\nCommit  :  "//#[[1]]//"\nResident:  "//#[[2]])&
      [ProcessStatus[{"vmsize", "ressize"}, "F"]];
    m = m//"\nNice    :  "//Read[ifs,Word];
    m = m//"\nStart   :  "//DateString[KBF$StartTime, Format->"ISO"];
    m = m//"\nDISPLAY :  "//Environment["DISPLAY"];
!  m = m//"\nTCPU     :  "//Read[ifs,Word];
!  m = m//"\nTReal    :  "//Read[ifs,Word];
    Close[ifs]];
  KBFMessageBox[m,Title->"About "//KBF$AppName,Font->TextFont[$DefaultFixedFont,"bold",KBF$DefaultFontSize]];
];

KBF$SADVersionInfo[] := KBFMessageBox[
  StandardForm[StringJoin["SAD",
    "\n  Version     : ", $Version,
    "\n  Source Rev. : ", $SourceRevision,
    "\n  Modified at : ", $SourceDate,
    "\n  Built  at   : ", $BuiltDate,
    "\nTcl/Tk",
    "\n  Version     : ", Tk$FullVersion]],
  Title->"About SAD", Font->TextFont[$DefaultFixedFont, KBF$DefaultFontSize, "bold"]];

KBF$HostFullName[System] := With[{host = HostName[]}, Which[
  Not[StringQ[host]],	With[{
    fp = OpenRead["!ifconfig -a|grep '^[ \t]*inet'|sed -e 's/^[ \t]*\\([^ \t]*\\)[ \t]*\\([^ \t]*\\).*/\\1 \\2/'"]},
    If[Not[RealQ[fp]], "localhost", With[{tbl = Sort[Table[With[{l = Read[fp, String]}, Which[
      Not[StringQ[l]],		Break[],	(* EndofFile *)
      (* Loopback:   0987654321 *)
      l[ -4, -1] ==       " ::1",	Null[],
      l[-10, -1] == " 127.0.0.1",	Null[],

      l[1, 6] == "inet6 ",	With[{ptr = GetHostByAddr[l[7, -1]]},
	If[StringQ[ptr], 1->ptr, 3->l[7, -1]]],

      l[1, 5] == "inet ",	With[{ptr = GetHostByAddr[l[6, -1]]},
	If[StringQ[ptr], 1->ptr, 2->l[6, -1]]],

      True,			Null[]]], {Infinity}]]},
      Close[fp];
      If[tbl === {}, "localhost", tbl[[1, 2]]]]]],

  StringPosition[host, ".", 1] <=> {},	host,	(* with domain suffix *)

  True,			With[{			(* hostname only *)
    fp = OpenRead["!grep '^[ \t]*domain' /etc/resolv.conf"
      //"|sed -e 's/^[ \t]*domain[ \t]*//' -e 's/[ \t]*$//'"]},
    With[{domain = If[RealQ[fp], Read[fp, String], EndOfFile]},
      Close[fp]; If[StringQ[domain], host//"."//domain, host]]]]];

KBF$HostFullName[] := With[{host = KBF$HostFullName[System]},
  KBF$HostFullName[] := host; host];

KBF$HostName[host_String:KBF$HostFullName[]] := With[{
  p4 = StringPosition[host, "."],
  p6 = StringPosition[host, ":"]},
  Which[
    p6 <=> {},	host,	(* WOULD be IPv6 *)

    p4 === {},	host,	(* without domain suffix *)

    And[Length[p4] == 3,
      With[{p = p4[[3, 2]], len = StringLength[host] - p4[[3, 2]],
	digits = "0"|"1"|"2"|"3"|"4"|"5"|"6"|"7"|"8"|"9"},
	Switch[{len, host[p + 1], host[p + 2], host[p + 3]},
	  {1, digits, _, _},					True,
	  {2, "1"|"2"|"3"|"4"|"5"|"6"|"7"|"8"|"9", digits, _},	True,
	  {3, "1", digits, digits},				True,
	  {3, "2", "0"|"1"|"2"|"3"|"4", digits},		True,
	  {3, "2", "5", "0"|"1"|"2"|"3"|"4"|"5"},		True,
	  _,							False]],
      True],	host,	(* WOULD be IPv4 *)

    True,	host[1, p4[[1, 1]] - 1]]];

KBF$MapInfoLabel[] := (
  KBF$InfoLabelAfterID = Null;
  If [KBF$IsInfoLabelCreated==False,
    KBF$InfoLabelWindow = Window[,Title->"info",BG->"lemonchiffon"];
    KBF$InfoLabel = TextLabel[KBF$InfoLabelWindow,BG->"lemonchiffon",PadX->1,PadY->1,Font->TextFont[$DefaultSansSerifFont,KBF$DefaultFontSize-2],Justify->"left"];
    KBF$InfoLabelWindow[OverrideRedirect]=True;
    KBF$IsInfoLabelCreated = True;
  ];
  KBF$InfoLabel[Text] = KBF$InfoLabelText;
  KBF$InfoLabelWindow[Geometry] = ToGeometry[Join[{,},
    Take[KBF$InfoLabelGeometry, 2]]];
  If[Not[KBF$IsInfoLabelMapped],
    KBF$InfoLabelWindow[Deiconify];
!    Update[IdleTasks]; ! MacX needs this, though I don't know why.
    KBF$InfoLabelWindow[Raise];
    KBF$IsInfoLabelMapped = True];
  KBF$InfoLabelAfterID =
    After[100, KBF$InfoLabelAfterID=Null; KBF$WithdrawInfoLabel[False]];
);

KBF$WithdrawInfoLabel[x_] := (
  If [KBF$IsInfoLabelMapped==True, KBF$InfoLabelWindow[Withdraw]];
  KBF$IsInfoLabelMapped = x;
  If [KBF$InfoLabelAfterID<=>Null,
    AfterCancel[KBF$InfoLabelAfterID];
    KBF$InfoLabelAfterID = Null
  ];
);

KBF$MoveCBForInfoLabel[s_] := (
  Switch [KBF$IsInfoLabelMapped
  ,True,
    If[KBF$InfoLabelText<=>s || ({X,Y}/.$Event)<=>KBF$InfoLabelXY,
      If[KBF$InfoLabelText<=>s, KBF$InfoLabelText=s];
      If [({X,Y}/.$Event)<=>KBF$InfoLabelXY,
	KBF$InfoLabelXY = {X,Y}/.$Event;
	KBF$InfoLabelGeometry = {8,15} 
	  + ({X,Y}/.$Event)+ WidgetInformation[Widget/.$Event,{RootX,RootY}];
	];
      KBF$InfoLabelAfterID = After[0.001, KBF$MapInfoLabel[]];
      ];
  ,False,
    KBF$InfoLabelText=s;
    KBF$InfoLabelXY = {X,Y}/.$Event;
    KBF$InfoLabelGeometry = {8,15}
      + ({X,Y}/.$Event)+ WidgetInformation[Widget/.$Event,{RootX,RootY}];
    If [KBF$InfoLabelAfterID<=>Null, AfterCancel[KBF$InfoLabelAfterID]];
    KBF$InfoLabelAfterID = After[0.001, KBF$MapInfoLabel[]];
   ,_, Print["KBF$IsInfoLabelMapped is broken: ", KBF$IsInfoLabelMapped];
  ];
);

(mb$_ = KBFAddMenuButton[x_,opts___]) ^:= 
  mb$ = MenuButton[x[$Frame$UserMenu], Side->"left", PadX->1, opts];

! KBFSetAboutMessage[s$_String] := (KBF$AboutMessage = s$;);

KBF$DoCopy[a_,c_] := Module[{},!Print[c];
  a[$Window][Selection$Own];
  a[$Window][Selection$Own] = selection->'CLIPBOARD';
  a[$Window][Clipboard$Clear];
  a[$Window][Clipboard$Append] = c;
];

KBF$ConfigureCB[] := (
  If [KBF$Dialog === {}, Return[]];
  If [KBF$ConfigTime === Null, After[0.1, KBF$Configure[]]];
  KBF$ConfigTime = FromDate[];
);

KBF$Open[dir_,fil_,c_,ao_] := Module[{fno,fname},
  If [(fname=KBFOpenDialog[dir,fil])===Null, Return[]];
  If [ao,
    fno = OpenRead[fname];
    c[fno];
    Close[fno];
  ,!Else
    c[fname];
  ];
];

KBF$GetDir[f_]:=Module[{p=StringPosition[f,"/"]},
  If[p==={},
    {"",f},
    {f[1,p[[-1,1]]],f[p[[-1,1]]+1,-1]}]];

KBF$SaveAs[dir_,fil_,c_] := Module[{fno,fname},
  If [(fname=KBFSaveDialog[dir,fil])===Null, Return[]];
  fno = OpenWrite[fname];
  KBF$SAFilename=fname;
  c[fno];
  Close[fno];
];

KBF$Configure[] := (
  If [FromDate[]-KBF$ConfigTime>0.1,
    KBF$DoConfigure[];
    KBF$ConfigTime = Null;
  ,!Else
    After[0.1, KBF$Configure[]]
  ];
);

KBF$DoConfigure[] := Module[{dl={},fl={},of,od,maxof,wl,p},
  If[KBF$Dialog === {}, Return[]];
  dl = With[{w=#},
    w[$Frame$ShellID]=FindShellID[w[$Frame$WindowID]]
    ]&/@KBF$Dialog[[,1]];!Print["dl2",dl];
  fl = With[{w=#},
    w[$Frame$ShellID]=FindShellID[w[$Frame$WindowID]]
    ]&/@KBF$FrameList;
  wl = XQueryTree[0][[3]];
  od = (p=Position[wl,#,1,1];If[p<=>{},p[[1,1]],0])&/@dl; ! XDarwin1.0.6.1 looks strange here.
  of = (p=Position[wl,#,1,1];If[p<=>{},p[[1,1]],0])&/@fl; ! XDarwin1.0.6.1 looks strange here.
  If[(Min[od,of]<=KBF$WMFlag)&&(Max[od]>Min[of]),
    XRaiseWindow[dl[[1]]];
    ];
  ];

KBF$MapCB[x_] := (
  x[$Frame$ShellID] = FindShellID[x[$Frame$WindowID]];
  If [x[$IsDialog],
    If [Length[KBF$Dialog]>1, KBF$Dialog[[2,1]][$Window][Grab$Release]];
!Print["map1"];
    KBF$Dialog[[1,1]][$Window][Grab$Set];
!Print["map2"];
  ];
  BindWidget[x[$Window], "<Map>",]
);
KBF$ReparentCB[x_] := (Print["KBF$Reparent"];
  x[$Frame$ShellID] = FindShellID[x[$Frame$WindowID]];
  KBF$WMFlag = 2;
);

!KBFRaise[kfr_] := XRaiseWindow[kfr[$Frame$ShellID]];
KBFRaise[kfr_] := kfr[$Window][Raise];
!KBFLower[kfr_] := XLowerWindow[kfr[$Frame$ShellID]];
KBFLower[kfr_] := kfr[$Window][Lower];

KBFRaise[a$_,n$_] := Module[{wl,lwl,sl,n},
  wl = XQueryTree[0][[3]];
  wid = a$[$Frame$ShellID];
  wl = DeleteCases[wl,wid];
  lwl = Length[wl];
  n = If [n$<0, lwl+n$+2, n$];
  If [n===1,
	a$[$Window][Raise];
  ,!Else
	If [n<=lwl+1,
	  XRestackWindows[{wl[[n-1]],wid}];
	,!Else
	  a$[$Window][Lower];
	];
  ];
];

KBFRaise[] := Module[{wl,fl,sl},
  If [Length[KBF$FrameList] > 1,
    sl = {};
    wl = XQueryTree[0][[3]];
    fl = Map[(#[$Frame$ShellID])&,KBF$FrameList];
    Scan[
      If [MemberQ[fl,#], sl = Append[sl,#]]&
    ,!List
      wl
    ];
    XRaiseWindow[sl[[1]]];
    XRestackWindows[sl];
  ,!Else
    XRaiseWindow[KBF$FrameList[[1]][$Frame$ShellID]];
  ];
];

KBFLower[] := Module[{wl,fl,sl},
  If [Length[KBF$FrameList] > 1,
    sl = {};
    wl = XQueryTree[0][[3]];
    fl = Map[(#[$Frame$ShellID])&,KBF$FrameList];
    Scan[
      If [MemberQ[fl,#], sl = Append[sl,#]]&
    ,!List
      wl
    ];
    XLowerWindow[sl[[1]]];
    XRestackWindows[sl];
  ,!Else
    XLowerWindow[KBF$FrameList[[1]][$Frame$ShellID]];
  ];
];

KBF$StartLauncher[] := With[{launcher = If[StringQ[KBF$Launcher],
  KBF$Launcher, KBF$DefaultLauncher]},
  System[If[launcher[-4,-1] <=> ".sad",
    launcher, KBF$SAD//" "//launcher]//" >/dev/null 2>&1 &"]];

KBF$StartSADInspect[] := System["env SADINSPECTTARGET='"//KBF$AppName//"' "
  //KBF$SAD//" "//PackagesDirectory//"SADInspect.sad >/dev/null 2>&1 &"];

KBF$MakeTaskMenu[x_] := Module[{ids,anl},
  x[$Menu$Task][Delete] = {1,"last"};
  anl = AppNames[];
  Scan[(
    With[{an=#},
      If[an==KBF$AppName,
        x[$Menu$Task][Add] = {Button[,Text->an//" *", State->"disabled"]};
      ,!Else
        x[$Menu$Task][Add] = {Button[,Text->an, State->"normal",
          Command:>Send[an,KBFRaise[]]]};
      ];
    ];
  )&
  ,!List
    anl
  ];
];

KBF$PageSetup[x_] := With[{r = KBF$PageSetupDialog[KBF$GetHardCopyConfig[x[HardCopyNameSpace]]]},
  Switch[r,
    _List,	KBF$SetHardCopyConfigList[x[HardCopyNameSpace], r]]];

With[{mm2pt = 72 / 25.4, A4points = {595, 842},
  ns$other = {"HardCopyOther:", "HardCopy:"},

  (* CAUTION: Order & Number of options are assumed in KBF$HardCopy[] & KBF$PageSetupDialog[] *)
  orientations = {"Portrait", "Landscape"},
  def$common = {
    "LeftMargin"->5, "RightMargin"->5, "TopMargin"->5, "BottomMargin"->5,
    "Scale"->0.8, "Orientation"->"Portrait"},
  Ncom = 4 + 1 + 1},	(* No. of common options MUST be equal to Length[def$common] *)

  (* HardCopy media configuration interface *)
  KBF$AddHardCopyMedia[media_String, copies_Real:Null, filter_String:Null] := And[
    media <> "", Position[KBF$HardCopyMedias[[, 1]], media, {1}, 1] === {}, With[{
      tag = If[KBF$HardCopyMedias === {}, "Copies", media//"Copies"]},
      If[StringQ[filter], KBF$HardCopyFilter[media] = filter];
      PkgConfig$Default["KBFrame", "HardCopy:", tag] = If[RealQ[copies], copies, -1];
      AppendTo[KBF$HardCopyMedias, media->tag];
      True]];

  KBF$HardCopyMedias = {};		(* Media List: {media-name->option-tag...} *)
  KBF$HardCopyFilter[_] := "";		(* Media filter script hash *)

  (* HardCopy default parameters *)
  PkgConfig$DefaultList["KBFrame"->Apply["HardCopy:"//#1->#2&, def$common, {1}]];
  KBF$AddHardCopyMedia["Paper", 1];

  PkgConfig$DefaultList["KBFrame"->{
    "HardCopy:IDPrefix"->"",
    "HardCopy:CommentPrefix"->"",
    "HardCopy:CommentSuffix"->"",
    Null[]}];

  (* Helper functions for HardCopy configuration *)
  KBF$HardCopyNameSpace[x_] := Which[
    x[$IsMain],			{ (* MainFrame *)
      "HardCopy["//If[StringQ[x[HardCopyName]], x[HardCopyName], KBF$AppBaseName]//"]:",
      "HardCopy:"},

    StringQ[x[HardCopyName]],	Prepend[KBF$HardCopyNameSpace[KBF$Window], "HardCopy["//x[HardCopyName]//"]:"],

    True,			KBF$HardCopyNameSpace[KBF$Window]];

  With[{common = def$common[[, 1]]},
    KBF$GetHardCopyConfig[ns_:{__String}] := KBF$GetHardCopyConfig[ns, Join[common, KBF$HardCopyMedias[[, 2]]]];
    KBF$GetHardCopyConfigList[ns_:{__String}] := KBF$GetHardCopyConfigList[ns, Join[common, KBF$HardCopyMedias[[, 2]]]];
    ];

  KBF$GetHardCopyConfig[ns_:{__String}, keys:{___String}] := If[Length[ns] > 1,
    Map[KBF$GetHardCopyConfig[ns, #]&, keys],
    PkgConfig["KBFrame", First[ns], keys]];
  KBF$GetHardCopyConfig[ns_:{__String}, key_String] := If[Length[ns] > 1,
    (Scan[With[{val = PkgConfig["KBFrame", #//key]}, If[val <=> Null, Return[val]]]&, ns]; Null),
    PkgConfig["KBFrame", First[ns], key]];

  KBF$GetHardCopyConfigList[ns_:{__String}, keys:{___String}] := Thread[Rule[keys, KBF$GetHardCopyConfig[ns, keys]]];

  KBF$SetHardCopyConfigList[ns_:{__String}, pairs:Rule[_String, _]...] := KBF$SetHardCopyConfigList[ns, {pairs}];
  KBF$SetHardCopyConfigList[ns_:{__String}, pairs:{Rule[_String, _]...}] := With[{prefix = First[ns]},
    PkgConfigList["KBFrame"->Apply[prefix//#1->#2&, pairs, {1}]]];

  (* for implementing backward compatible setter: a[$HC$Scale] *)
  KBF$SetHardCopyConfig[ns:{__String}, conf:{_Real, _Real, _Real, _Real, _Real, _Real, {_Real, _Real}}] := With[{
    Nmed = Length[KBF$HardCopyMedias]},

    KBF$SetHardCopyConfigList[ns, Join[
      Thread[Rule[def$common[[, 1]], Take[conf, Ncom]]]/.{
	("Orientation"->v_Real):>("Orientation"->Part[orientations, Restrict[Floor[v], 1, Length[orientations]]])},
      Thread[Rule[KBF$HardCopyMedias[[, 2]],
	Take[Join[Last[conf], Table[0, {Nmed}]], Nmed]]]]]];

  (* HardCopy PageSetup Dialog *)
  KBF$PageSetupDialog[config$_List] := With[{medias = KBF$HardCopyMedias[[, 1]]}, Module[{r,
    lm, rm, tm, bm, sc, pl, nmed, med},
    
    {lm, rm, tm, bm, sc, pl} = Take[config$, Ncom];
    ScanThread[(nmed[#1] = Abs[#3]; med[#2] = (#3 > 0))&,
      {medias, Range[Length[medias]], Take[config$, Ncom + {1, Length[medias]}]}];

    sc *= 100;
    If[StringQ[pl], pl = Switch[pl[1],
      "l"|"L",	2,	(* Landscape *)
      _,	1]];	(* Otherwise Portrait *)

    r = KBFOptionDialog[Title->"Print", Add->{
      KBFGroup[Text->"Page Setup"],
      Null@@Map[With[{media = #},
	KBFNumber[Variable:>nmed[media], Text->"No. of copies ("//media//"):"]]&,
	medias],
      KBFNumber[Variable:>lm, Text->"Left Margin (mm):"],
!      KBFNumber[Variable:>rm, Text->"Right Margin (mm):"],
!      KBFNumber[Variable:>tm, Text->"Top Margin (mm):"],
      KBFNumber[Variable:>bm, Text->"Bottom Margin (mm):"],
      KBFNumber[Variable:>sc, Text->"Scale (%):"],
      KBFSeparator[],
      KBFRadioButton[Variable:>pl, Columns->2, Items->orientations],
      KBFCheckButton[Variable:>med, Columns->Length[medias], Text->medias],
      Null[]}];

    If[r <=> 0,
      Join[Thread[Rule[def$common[[, 1]], {lm, rm, tm, bm, sc/100, orientations[[pl]]}]],
	MapThread[#1->If[#2, Max[0, #3], -Max[0, #3]]&,
	  {KBF$HardCopyMedias[[, 2]], med/@Range[Length[medias]], nmed/@medias}]],
      0]]];

  (* HardCopy *)
  KBF$HardCopy[x_, self_Real:True, print_:True] := Module[{t0 = FromDate[Tick->0],
    maxRetry = If[RealQ[KBF$ScreenShotPerSecond] && KBF$ScreenShotPerSecond > 0, KBF$ScreenShotPerSecond, 100],
    copyID, comment,
    lm, rm, tm, bm, sc, pl, nmed, cancel = False,
!!    w, h,
    pw, ph, xwd, retry, name,
    status$lock = x[$Frame$StatusLock], status$text = x[$Frame$StatusText][Text]},

    (* Setup status line for HardCopy *)
    x[KBF$ClockStop]; x[KBF$ClockUpdate];
    x[$Label$Print][Picture] = "printerlogo2";
    If[Not[x[$Frame$StatusLock]], x[$Label$Stat][Text] = x[$Frame$StatusText]];
    x[$Frame$StatusLock] = True;
    Update[IdleTasks];

    copyID = With[{prefix = PkgConfig["KBFrame", "HardCopy:IDPrefix"]},
      Switch[{prefix, KBF$HardCopyID},
	{_String, _String},	prefix//KBF$HardCopyID,
	{      _, _String},	KBF$HardCopyID,
	_,			""]];

    comment = With[{$PkgConfig = With[{c = PkgConfig[##]}, If[StringQ[c], c, ""]]&},
      StringJoin[
	$PkgConfig["KBFrame", "HardCopy:CommentPrefix"],
	KBF$AppBaseName,
	$PkgConfig["KBFrame", "HardCopy:CommentSuffix"]]];

    With[{config = If[self,
      With[{fr = x[$Window]},						(* self window *)
!!	{w, h} = {WidgetInfo[fr, Width], WidgetInfo[fr, Height]};
	KBF$GetHardCopyConfig[x[HardCopyNameSpace]]],
      With[{r = KBF$PageSetupDialog[KBF$GetHardCopyConfig[ns$other]]},	(* other window *)
	Switch[r,
	  _List,	KBF$SetHardCopyConfigList[ns$other, r],
	  _,		cancel = True];
	KBF$GetHardCopyConfig[ns$other]]]},
      {lm, rm, tm, bm, sc, pl} = Take[config, Ncom];
      nmed = Drop[config, Ncom]];

    If[nmed <=> {}, Switch[print,
      Print,	( (* Print only 1-page to default media *)
	nmed *= 0;
	nmed[[1]] = 1),

      False,	( (* Disable all printing action *)
	nmed *= 0),

      _,	(* Otherwise default print action *)]];

    {pw, ph} = Switch[pl[1],
      "l"|"L",	Reverse[A4points],	(* Landscape *)
      _,		A4points];	(* Default/Portrait *)

    If[Not[pw > (lm + rm) * mm2pt && ph > (tm + bm) * mm2pt], cancel = True];	(* Check paper margin *)

    If[And[Not[cancel], (
      Update[WindowTasks, IdleTasks];
      xwd = If[self, KBF$HardCopy$GetXWD[x[$Frame$WindowID]], KBF$HardCopy$GetXWD[]]) <=> $Failed], StandardForm[
	(* XWD screen shot in temporary file `xwd' *)

	With[{dir = KBF$HardCopy$Mkdir[t0]}, If[dir <=> $Failed,	(* Store screen shot *)
	  For[retry = 0, retry < maxRetry, ++retry, With[{name = KBF$HardCopy$Name[copyID, t0, retry]},
	    If[KBF$HardCopy$Store[xwd, dir, name],
	      Print[name];
	      KBF$HardCopy$InsertIndex[dir, name, comment]; Break[]]]]]];

	If[KBF$PrinterName <=> Null && KBF$convert <=> Null, With[{
	  lpr$P = If[StringQ[KBF$PrinterName], " -P "//KBF$PrinterName, ""],	(* Named/default queue *)
	  cmd$toPS = With[{dpi = Ceiling[72 / sc]}, StringJoin[KBF$convert,
	    " -page A4+", Floor[lm * mm2pt], "+", Floor[bm * mm2pt],
	    If[pw > ph, " -rotate 90", " -rotate 180"],
	    " -density ", dpi, "x", dpi, " xwd:", xwd, " ps:-"]]},

	  ScanThread[If[#1 > 0, System[StringJoin[cmd$toPS,
	    KBF$HardCopyFilter[#2],
	    " | lpr", lpr$P, " -# ", #1]]]&,
	    {nmed, KBF$HardCopyMedias[[, 1]]}];

	  ]];
	
	DeleteFile[xwd]]];

    (* Restore status line *)
    x[$Frame$StatusLock] = status$lock;
    If[Not[x[$Frame$StatusLock]], x[$Label$Stat][Text] = status$text];
    x[$Label$Print][Picture] = "printerlogo"];
  ];

With[{	(* ScreenShot tunable defaults *)
  DefaultUmask = "0",
  DefaultType = "png"},

! Get screen shot of given `id' by XWD format and return temporary file path or $Failed
  KBF$HardCopy$GetXWD[id_Real:Null] := With[{tmp = MkSecureTemp[]}, Which[
    tmp === $Failed,								$Failed,
    Check[And[KBF$xwd <=> Null, 0 == System[StringJoin[KBF$xwd,
      If[RealQ[id], StandardForm[" -id "//id], ""], " -out ", tmp]]], False],	tmp,
    True,						(DeleteFile[tmp];	$Failed)]];

! Make individual screen shot directory with 0777 permission and return full path or $Failed
  KBF$HardCopy$Mkdir[t_Real] := With[{subdir = ToDateString[t, Format->"+%Y_%m/%d"],
    root = Switch[KBF$ScreenShotDirectory,
      _String,		KBF$ScreenShotDirectory,
      _,		Null]},
    If[StringQ[root] && Check[System[StringJoin["umask ", Switch[KBF$ScreenShotUmask,
      _String,	KBF$ScreenShotUmask,
      _,	DefaultUmask], " ; cd ", EscapeShellMetaCharacter[root],
      " && mkdir -p ", subdir]] == 0, False], root//"/"//subdir, $Failed]];

! Make screen shot file name with `trial' suffix
!  Backword compatible replacements...
!   U+0020(SPACE)						-> U+005F(LOW LINE)
!   U+0025(PERCENT SIGN)					-> U+005F(LOW LINE)
!  Special chacater in `id' String is replaced as...
!   U+0009(CHARACTER TABULATION/meta character of index.txt)	-> U+005F(LOW LINE)
!   U+002F(Solidus/path separator)				-> U+FF0F(Fullwidth Solidus)
!   U+0000(NULL/string terminator in C)				-> U+005C(Reverse Solidus) + U+0030(Digit Zero)
  KBF$HardCopy$Name[id_String:"", t_Real, trial_Real:0] := StringJoin[
    ToDateString[t, Format->"+%Y_%m_%d_%H_%M_%S"], StringReplace[id, {
      " "->"_", "%"->"_",		(* Backword compatible replacements for U+0020/U+0025 *)
      "\t"->"_",			(* Map index.txt separator white-space charater into `_' like ' ' mapping *)
      "/"->"\uFF0F", "\0"->"\\0"}],
    If[trial < 1, "", StandardForm["("//trial//")"]],
    ".", Switch[KBF$ScreenShotType,
      _String,	KBF$ScreenShotType,
      _,	DefaultType]];

! Store screen shot file named `file' into `dir' from XWD file `xwd' and return True(success) or False(fail)
!  Path `xwd' is assumed mkstemp(3) generated path without shell meta character
  KBF$HardCopy$Store[xwd_String, dir_String, file_String] := If[".xwd" === file[-4, -1],
    Check[			    (0 == System[StringJoin[
      "umask 222 ; cd ", EscapeShellMetaCharacter[dir],
      " && ", "cp ",                xwd, " ", EscapeShellMetaCharacter[file], " 2>/dev/null"]]), False],
    Check[(KBF$convert <=> Null) && (0 == System[StringJoin[
      "umask 222 ; cd ", EscapeShellMetaCharacter[dir],
      " && ", KBF$convert, " xwd:", xwd,
      " ", Switch[KBF$ScreenShotType,
	_String,	KBF$ScreenShotType,
	_,		DefaultType], ":-",
      " >", EscapeShellMetaCharacter[file], " 2>/dev/null"]]), False]];

! Insert screen shot file named `file' into index.txt on `dir' directory with `comment' under flock(2)
! FIXME: Confirm mutex method with KEKB control group
  KBF$HardCopy$InsertIndex[dir_String, file_String, comment_String] := With[{
    umask0 = Umask[Switch[KBF$ScreenShotUmask,
      _String,	KBF$ScreenShotUmask,
      _,	DefaultUmask]]},
    With[{fp = OpenAppend[dir//"/index.txt"]}, If[(Umask[umask0]; RealQ[fp]), With[{r = And[
      Check[(While[Not[FileLock[fp, Lock$Exclusive]], Null]; True), False],	(* Obtain exclusive lock[blocking] *)
      Check[(While[Read[fp, String] <=> EndOfFile, Null]; True), False],	(* Move to file end by READ *)
      (* CAUTION: Don't replace with SeekFile[fp, 0, EndOfFile] *)
      (*          SeekFile[] from EndOfFile does not work correctly in this case: *)
      (*          index.txt was appended by other process bedore exclusive locking. *)
      (* FIXME: ``READ before WRITE'' file seek depends with Fortran runtime implementation *)
      Check[(WriteString[fp, StringJoin[file, "\t", comment, "\n"]]; True), False]]},
      Close[fp]; r], False]]];

  ];	(* End ScreenShot tunable defaults region *)

KBF$MakePDF[a$_]:=Module[{f=KBFSaveDialog[KBF$Dir,"*"],ff},
  If[f<=>Null,
    {KBF$Dir,ff}=KBF$GetDir[f];
    KBFMakePDF[f,{a$[$Window]}]]];

KBFMakePDF[s$_,l_:KBF$FrameList] := Module[{s,ld,lid},
  If[Not[KBF$convert <=> Null], Print["convert is not found."]; Return[]];
  s = If [StringMatchQ[s$[-4,-1],".PDF|.pdf"], s$[1,-5], s$];
  lid = Map[With[{wid = If[Head[#]===Widget,WidgetInfo[#,ID],#[$Frame$WindowID]]},
    If[Not[RealQ[wid]],Print["can't get window id."]; Return[]];
    wid]&,l];
  ld = MapThread[(
    Do[(If[Head[#1]===Widget,#1[Raise],KBFRaise[#1]]; Update[WindowTasks,IdleTasks]), {2}];
    With[{fn = KBF$HardCopy$GetXWD[#2]}, If[fn === $Failed, Null[], fn]])&, {l, lid}];
  If[Length[ld] < 0, Print["can't dump window."]; Return[]];
  
  System[StringJoin[KBF$convert," -density 80x80 -page 842x595+30+30 ",
    StringJoin@@Rest[Flatten[Thread[{" ", "xwd:", ld}]]]," ",s//".pdf",
    "; rm ",StringJoin@@Rest[Flatten[Thread[{" ", ld}]]]]]];

KBF$MakeWindowMenu[x_] := (
  x[$Menu$Window][Delete] = {1,"last"};
  Scan[(
    With[{wsym=#,xx=x}, xx[$Menu$Window][Add] = {Button[,Text->#[$Frame$Name], State->KBF$State[# <=> xx],Command:>KBFRaise[wsym]]}]
  )&,KBF$FrameList];
  With[{shellid=KBF$Console,st=KBF$State[KBF$Console <=> Null],xx=x},
    xx[$Menu$Window][Add] = {Separator[],Button[,Text->"Make Snapshot",Command:>KBF$MakeWindowSnapshot[xx]]};
    xx[$Menu$Window][Add] = {Separator[],Button[,Text->"Console",State->st,Command:>(XRaiseWindow[Tk$ShellID];XRaiseWindow[shellid])]};
    xx[$Menu$Window][Add] = {Button[,Text->"Prompt",State->st,Command:>(XRaiseWindow[shellid];TkReturn["ReturnToSAD"];)]};
    If[KBF$SADTerminal===Null,xx[$Menu$Window][Add] = {Separator[],Button[,Text->"SADTerminal",Command:>KBF$MakeSADTerminal[x]]}];
  ];
);

KBF$MakeWindowSnapshot[x_] := And[KBF$xwd <=> Null, KBF$xwud <=> Null,
  System[StandardForm[StringJoin[KBF$xwd," -id ",x[$Frame$WindowID],"|",KBF$xwud," -noclick&"]]]];

KBF$WindowClose[_] := Null;
SetAttributes[KBF$WindowClose, HoldAll];

KBF$AppExit[] := Module[{},
  KBF$CloseTerminal[];
  If [MemberQ[AppNames[],KBF$LauncherName]&&(KBF$AppName<=>KBF$LauncherName),
    With[{an=KBF$AppName},
      Send[KBF$LauncherName, AppStopNotify[an]];
    ];
  ];
  Scan[System["rm -f "//#]&,KBF$PSList];
  KBF$ExitCommand[];
  TkReturn[0];
  Exit[];
];

KBF$Calculator[] := (KBF$xcalc <=> Null && System[KBF$xcalc//"&"]);

KBF$ReadCapFile[fn_String] := Module[{fp, buf = Null},
  If[Not[FileQ[fn] && RealQ[fp = OpenRead[fn]]], {},
    Map[With[{p1 = StringPosition[#, ":"][[,1]], s = #},
      With[{l = MapThread[s[#1, #2]&, {Prepend[p1 + 1, 1], Append[p1 - 1, -1]}]},
	If[Length[l] < 1, Null[],
	  With[{p2 = StringPosition[First[l], "|"][[,1]], s = First[l]},
	    MapThread[s[#1, #2]&, {Prepend[p2 + 1, 1], Append[p2 - 1, -1]}]]->With[{spaces = ToCharacterCode[" \t"]},
	      Select[Rest[l], Complement[ToCharacterCode[#], spaces] <=> {}&]]]]]&,
      Table[With[{s = Read[fp, String]}, Switch[s,
	EndOfFile,	If[buf === Null, (Close[fp]; Break[]), With[{out = buf}, buf = Null; out]],
	_String,	Which[
	  s === "" || s[1] === "#",	Null[],								(* Comment *)
	  s[-1] === "\\",		(buf = If[buf <=> Null, buf//s[1, -2], s[1, -2]]; Null[]),	(* Continue *)
	  True,				If[buf <=> Null, With[{out = buf}, buf = Null; out//s], s]]]],
	{Infinity}]]]];

KBF$ListPrinters[] := Module[{keys, entry, fp, s,
  lp$interface = "/etc/lp/interface"},

  entry[_] := {}; keys = {};

  (* lp/interface *)
  If[DirectoryQ[lp$interface],
    fp = OpenRead["!ls -1 "//lp$interface];
    If[fp <=> $Failed,
      While[s = Read[fp, String]; s <=> EndOfFile,
	AppendTo[keys, s]];
      Close[fp]];
    ];

  (* printcap *)
  Scan[With[{key = First[#], aliases = Rest[#]},
    AppendTo[keys, key];
    entry[key] = Join[entry[key], aliases]]&,
    (Join@@KBF$ReadCapFile/@{"/etc/printcap", "/usr/local/etc/printcap"})[[,1]]];

  (* lps status *)
  fp = OpenRead["!env LANG=C lpc status 2>&1 | grep -e ':$' | sed -e 's/:$//'"];
  If[fp <=> $Failed,
    While[s = Read[fp, String]; s <=> EndOfFile,
      AppendTo[keys, s]];
    Close[fp]];

  Map[With[{pl = Prepend[Union[entry[#]], #]},
    {StringJoin@@Rest[Flatten[Thread[{" / ", pl}]]], pl}]&, Union[keys]]];

KBF$DefaultPrinter[] := Module[{fp, pr}, Which[
  And[RealQ[fp = OpenRead["!env LANG=C lpstat -d 2>/dev/null | sed -e 's/^[^:]*: *//'"]],
    StringQ[(pr = Read[fp, String]; Close[fp]; pr)]],		pr,

  And[RealQ[fp = OpenRead["!env LANG=C lpq 2>/dev/null | head -1 | sed -e 's/ .*//'"]],
    StringQ[(pr = Read[fp, String]; Close[fp]; pr)]],		pr,

  True,								Null]];	(* default printer is NOT configured *)

Switch[KBF$PrinterName,
  _String|Null,	(* Keep configured valud *),
  _,		KBF$PrinterName = Automatic];

KBF$PrinterChooser[] := Module[{default = KBF$DefaultPrinter[], pl = KBF$ListPrinters[], lp, np, r},
  lp = Switch[KBF$PrinterName,
    Null,	Null,
    _String,	KBF$PrinterName,
    _,		default];
  With[{pos = Position[pl[[, 2]], lp, {2}, 1]},
    np = If[pos <=> {}, pos[[1, 1]] + 1, 1]];
  r = KBFOptionDialog[Title->"Printer Chooser", Add->{
    KBFGroup[Text->"Choose A Default Printer."],
    KBFText[Text->"Current Printer: "//Which[
      np > 1,		lp,
      StringQ[lp],	lp//"<invalid-printer>",
      True,		"<no-printing>"]],
    KBFListBox[Text->"Printers:", Items->Prepend[pl[[,1]], "<no-printing>"], Variable:>np],
    Null[]}];
  If[r <> 0, KBF$PrinterName = If[np == 1, Null, pl[[np - 1, 2, 1]]]];
  ];

(cf_ = KBFComponentFrame[p_, opt___]) ^:= Module[
  {{add,ht,tr,other}=SwitchCases[Override[opt],{Rule[Add,_],Rule[Height,_],Rule[Transparent,_],_}],
   if,isb,ic,icf,i=1},
  other=Override[other/.((Background->x_)->(BG->x))];
  other=other/.((BG->Transparent)->(BG->p[Background]));
  cf[i]=Frame[p,other];if=i++;
  With[{j=i-1},(cf =.) ^:= DeleteWidget[cf[j]]];
  ht = Height/.ht/.Height->Null;
  If [ht<=>Null,
    cf[i] = ScrollBar[cf[if],
      Orient->"vertical",Side->"right",Fill->"y",Width->9,BD->1];isb=i++;
    With[{isb}, cf[i] = Canvas[cf[if],Height->ht,BG->cf[if][Background],
      YScrollCommand:>cf[isb][Set]]];ic=i++;
    cf[i] = Frame[cf[ic],BG->cf[ic][Background]];icf=i++;
    cf[ic][Create$Window] = {0,0,Window->cf[icf],Anchor->"nw"};
    With[{ic,icf},Bind[cf[icf],"<Configure>",cf[ic][Width]=WidgetInfo[cf[icf],Width];cf[ic][ScrollRegion] = {0,0,2000,WidgetInfo[cf[icf],Height]}]];
  ];
  If[add<=>{}, KBF$ArrangeComponents[cf,i-1,i,Unevaluated$[add[[1,2]]],Null@@tr]];
];

KBF$ArrangeComponents[w_,np_,i0_,add_,opt___] := Module[
    {lv={},icf=np,icft1,icgf=np,icsgf,icgf0,icft2,btv,vtmp,acomp,t,v,o,c,n,wv,twv,us,cn,to,co,newcolumn,bgcolor,i=i0,ep,
      nf,ew,cp,rg,bd,cl,ot,dnf,dew,dcp,drg,dbd,dp,fx,rem,it,ilb,
      iupad,idpad,gfr,lo,bg,trbg,transparent,conflict,spb,
    (*  epad = {PadX->20}; tpad = {PadX->5}; rpad = {PadX->30}; opad = {PadX->30}; lpad = {PadX->20}; K. Oide 2/25/2001 *)
    (*  epad = {PadX->10}; tpad = {PadX->2}; rpad = {PadX->15}; opad = {PadX->10}; lpad = {PadX->10}; *)
    epad = {PadX->2}, tpad = {PadX->1}, rpad = {PadX->4}, opad = {PadX->2}, lpad = {PadX->2},
    scol = {BG->"white",(* SelectBackground->"wheat", *)SelectForeground->"black",SelectBorderWidth->0},
    vdnf,vdew,vdcp,vdrg,vdbd,vdp,vlo,
    opt$inherit},

  {vdnf, vdew, vdcp, vdrg, vdbd, vdp, vlo} = SwitchCases[Override[opt,
    { DefaultNumberForm->Null,
      DefaultEntryWidth->15,
      DefaultCursorPosition->-1,
      DefaultRange->Null,
      DefaultBD->1,
      DefaultPad->True,
      LooseOption->False,
      Null[]}],
    { Rule[DefaultNumberForm,_], Rule[DefaultEntryWidth,_],
      Rule[DefaultCursorPosition,_], Rule[DefaultRange,_],
      Rule[DefaultBD,_], Rule[DefaultPad,_],
      Rule[LooseOption,_],
      Null[]}][[,1,2]];

  opt$inherit := {
    DefaultNumberForm->vdnf,
    DefaultEntryWidth->vdew,
    DefaultCursorPosition->vdcp,
    DefaultRange->vdrg,
    DefaultBD->vdbd,
    DefaultPad->vdp,
    LooseOption->vlo,
    Null[]};

  newcolumn[True] := (
    w[i] = Frame[w[icsgf],Fill->"x",Side->"left",If[fx,Expand->True,Null[]],Anchor->"n",Null@@trbg[icsgf]];icf=i++
      );
  btv = TemporaryVariable/.{opt}/.TemporaryVariable->False;
  transparent = Transparent/.{opt}/.Transparent->False;
  trbg[id_Real] := If[transparent, {BG->w[id][Background]}, {}];
  bg[copt_List] := First[SwitchCase[copt, Rule[BG,_]]];
  bgcolor[id_Real, copt_List] := (
    copt/.((BG->Transparent)->(BG->w[id][Background]))
    /.((HighlightBackground->Transparent)->(HighlightBackground->w[id][Background]))
    );
  w[i] = Frame[w[np],Side->"left",Fill->"x",Expand->True,Anchor->"n",
    Null@@trbg[np]];icgf=i++;
  If[add=={}, Return[If[btv, {i,lv}, i]]];
  Scan[(
    {acomp,t,v,o,c,n,wv,twv,us,cn,to,co,nf,ew,cp,rg,bd,cl,ot,dnf,dew,dcp,drg,dbd,dp,fx,lo,spb,rem} =
      SwitchCases[If[#<=>Null,#,{}],{Rule[Add,_],Rule[Text,_],RuleDelayed[Variable,_],Rule[Items,_],RuleDelayed[Command,_],
        Rule[NextColumn,_],RuleDelayed[WidgetVariable,_],RuleDelayed[TextWidgetVariable,_],Rule[UnitString,_],
        RuleDelayed[WidgetName|ComponentName,_],Rule[TextWidgetOption,_],Rule[ComponentOption|WidgetOption,_],
	Rule[NumberForm,_],Rule[EntryWidth,_],
	Rule[CursorPosition|DefaultPosition,_],Rule[Range,_],
	RuleDelayed[Bind,_],Rule[Columns,_],Rule[OverrapText,_],
	Rule[DefaultNumberForm,_],Rule[DefaultEntryWidth,_],
	Rule[DefaultCursorPosition,_],Rule[DefaultRange,_],
	Rule[DefaultBD,_],Rule[DefaultPad,_],
	Rule[FillX,_],Rule[LooseOption,_],Rule[SpinBox,_],_}];
    n=(n<=>{}&&n[[1,2]]);
    If[co<=>{},co=co[[1,2]]];
    If[to<=>{},to=to[[1,2]]];
    co=Override[co/.((Background->x_)->(BG->x))];
    to=Override[to/.((Background->x_)->(BG->x))];
    If [dnf<=>{}, vdnf = dnf[[1,2]]];
    If [dew<=>{}, vdew = dew[[1,2]]];
    If [dcp<=>{}, vdcp = dcp[[1,2]]];
    If [drg<=>{}, vdrg = drg[[1,2]]];
    If [dbd<=>{}, vdbd = dbd[[1,2]]];
    If [dp<=>{}, vdp = dp[[1,2]]];
    ep=If[vdp,epad,{}];
    nf = If [nf<=>{}, nf[[1,2]], vdnf];
    ew = If [ew<=>{}, ew[[1,2]], vdew];
    cp = If [cp<=>{}, cp[[1,2]], vdcp];
    rg = If [rg<=>{}, rg[[1,2]], vdrg];
    fx = If [fx<=>{}, fx[[1,2]], True];
    If [lo<=>{}, vlo = lo[[1,2]]];
    If [vlo, co = Join[co,rem]];
    Switch[#
      ,(KBFGroup|KACGroup)[___],
      If[transparent, co=Override[co,BG->Transparent]];
      If[transparent, to=Override[to,BG->Transparent]];
      gfr = Frame/.rem/.Frame->True;
      If [n,
        w[i] = Frame[w[np],Side->"left",Fill->"x",Expand->True,Anchor->"n",
	  Null@@trbg[np]];icgf=i++;
        ];
      With[{twsym=If[twv<=>{},twv[[1,2]],w[i]]}, 
	twsym = LabelFrame[w[icgf],
	  Null@@bgcolor[icgf,bg[co]],
	  Null@@If[gfr, {Relief->"groove", BD->vdbd*2}, {Relief->"flat", BD->0}],
	  IPadY->If[gfr, 0, Floor[(Height/.rem/.Height->5)/2]],
          Fill->"x", PadX->0,
          Null@@If[t<=>{},
	    {First[t], Font->(Font/.rem/.(Font->TextFont[$DefaultSansSerifFont,"bold",KBF$DefaultFontSize-2]))}, {}]
	  ];icsgf=i++;If[twv<=>{},w[icsgf]=twsym];
	  If[Not[btv]&&v<=>{},With[{$v$=Extract[v,{1,2},Unevaluated$],$prev$=v[[1,2]]},
	    $v$ := twsym[Text];
	    ($v$ = $text$_) ^:= (twsym[Text] = $text$);
	    If[t==={}, $v$ = $prev$]]];
	];
      newcolumn[True];
(*      w[i] = Frame[w[icgf],Fill->"x",Null@@bgcolor[icgf,bg[co]]];icgf0=i++;
      If [gfr,
	w[i] = Frame[w[icgf0],Height->5,Null@@bgcolor[icgf0,bg[co]]];iupad=i++];
      w[i] = Frame[w[icgf0],Null@@bgcolor[icgf0,co],
	If[gfr,{BD->vdbd*2,Relief->"groove",IPadY->1},Null[]],
        PadX->0,
        Fill->"x"];icsgf=i++;
      w[i] = Frame[w[icsgf],Height->(Height/.rem/.Height->5),Null@@bgcolor[icsgf,bg[co]]];idpad=i++;
      If[t<=>{},
        With[{twsym=If[twv<=>{},twv[[1,2]],w[i]]}, 
          twsym = TextLabel[w[icgf0],Null@@bgcolor[icgf0,to],t,
            Font->(Font/.rem/.(Font->TextFont[$DefaultSansSerifFont,"bold",12])),GM->Place,Anchor->"nw",X->20+2*(vdbd-1),Y->0]];i++;
        With[{iupad,idpad,vdbd,it=i-1},
	  Bind[w[it],"<Map>",
     Function[{h},w[iupad][Height]=h*.6-vdbd;w[idpad][Height] = h*.4-vdbd;Bind[w[it],"<Map>",]][WidgetInfo[w[it],Height]]];
	  ]
        ];
      w[i] = Frame[w[icsgf],Side->"left",Fill->"x",If[fx,Expand->True,Null[]],Anchor->"n",Null@@bgcolor[icsgf,bg[co]]];icf=i++; *)

      ,(KBFSeparator|KACSeparator)[___],
      If[transparent, co=Override[co,BG->Transparent]];
      With[{wsym=If[wv<=>{},wv[[1,2]],w[i]]}, wsym = Frame[w[icf],
	Null@@bgcolor[icf,co],
        (* PadX->10,PadY->3, K. Oide 2/25/2001 *)
        PadX->3,PadY->1,
        BD->vdbd,Height->vdbd*2,Fill->"x",Relief->"sunken"]];i++;

      ,(KBFText|KACText)[__],
      If[transparent, co=Override[co,BG->Transparent]];
      newcolumn[n];
      With[{wsym=If[wv<=>{},wv[[1,2]],w[i]]}, 
        wsym = TextLabel[w[icf],t,
	  Null@@bgcolor[icf,Override[to,co]],
	  TextAnchor->"w",Justify->"left",
          If[vdp,tpad,Null[]],(v/.Variable->TextVariable),Fill->"x"]];i++;

      ,(KBFString|KACString)[__],
      If[transparent, to=Override[to,BG->Transparent]];
      newcolumn[n];
      If [v<=>{}&&Not[StringQ[Variable/.v]],
        Evaluate[Extract[v,{1,2},Unevaluated$]]="";
        ];
      If [v<=>{}&&btv,
        w[i] = Variable/.v;
        lv = Append[lv, Head[#][v[[1]],i]];
        With[{i}, v = {Variable:>w[i]}];i++;
        ];
      w[i] = Frame[w[icf],Fill->"x",Null@@ep,
	Null@@bgcolor[icf,bg[to]]];icft1=i++;
      If [t<=>{}, With[{twsym=If[twv<=>{},twv[[1,2]],w[i]]}, 
        twsym = TextLabel[w[icft1],Null@@bgcolor[icf,to],
	  t,Fill->"x",TextAnchor->"w",Side->"left"]];i++;
        w[i] = Frame[w[icft1],t,Width->5,Side->"left",
	  Null@@bgcolor[icf,bg[to]]];i++];
      spb=((SpinBox/.spb/.SpinBox->False) === True);
      With[{wsym=If[wv<=>{},wv[[1,2]],w[i]]},
        wsym = If[spb,SpinBox,Entry][w[icft1],Null@@bgcolor[icf, co],If[c<=>{},c[[1]]],
	  If[RealQ[ew],Null[Width->ew, Side->"right"],Fill->"x"],
	  (v/.Variable->TextVariable),BD->vdbd,Justify->"left",scol]];i++;

      ,(KBFNumber|KACNumber)[__],
      If[transparent, to=Override[to,BG->Transparent]];
      newcolumn[n];
      If [Not[StringQ[nf]], nf=""];
      If [v<=>{},
        If [btv,
          StandardForm[$FORM=nf; w[i] = ToString[Variable/.v]];
          lv = Append[lv, Head[#][v[[1]],i]];
          With[{i}, v = {Variable:>w[i]}];i++;
          ,!Else
          With[{vname=Extract[v,{1,2},Unevaluated$],$prev$=If[RealQ[v[[1,2]]],v[[1,2]],0],i},
	    conflict = Switch[If[Depth[Hold[vname]] == 2, Hold[vname],
	      Extract[Hold[vname], {1,0}, Hold]],
	      Hold[val], True, _, False];
            Clear[vname];
            w[i] = $prev$;
            With[{nf,rg,ivp=i+1,isp=i+2},
	      w[ivp] = $prev$;
	      w[isp] = w[i];
              Switch[rg,
                {_Real,_Real},
                vname := StandardForm[$FORM=nf;Module[{r=ToExpression[w[i]]},
		  r=If[RealQ[r]&&w[i]<=>w[isp],Restrict[r,rg[[1]],rg[[2]]],w[ivp]];
                  w[isp]=w[i]=ToString[r];w[ivp]=r]];
		If[Not[conflict],
		(vname=val_Real) ^:= StandardForm[w[ivp]=Restrict[val,rg[[1]],rg[[2]]];$FORM=nf;w[isp]=w[i]=ToString[w[ivp]];w[ivp]],
		(vname=Val_Real) ^:= StandardForm[w[ivp]=Restrict[Val,rg[[1]],rg[[2]]];$FORM=nf;w[isp]=w[i]=ToString[w[ivp]];w[ivp]]],
                _,
                vname := StandardForm[$FORM=nf;Module[{r=ToExpression[w[i]]},
		  r=If[RealQ[r]&&w[i]<=>w[isp],r,w[ivp]];
                  w[isp]=w[i]=ToString[r];w[ivp]=r]];
		If[Not[conflict],
		(vname=val_Real) ^:= StandardForm[w[ivp]=val;$FORM=nf;w[isp]=w[i]=ToString[w[ivp]];w[ivp]],
		(vname=Val_Real) ^:= StandardForm[w[ivp]=Val;$FORM=nf;w[isp]=w[i]=ToString[w[ivp]];w[ivp]]];
		];
	      ];
            vname = $prev$;
            v = {Variable:>w[i]};
            ];i+=3;
          ];
        ];
      w[i] = Frame[w[icf],Fill->"x",Null@@ep,
	Null@@bgcolor[icf,bg[to]]];icft1=i++;
      If[t<=>{}, With[{twsym=If[twv<=>{},twv[[1,2]],w[i]]}, 
        twsym = TextLabel[w[icft1],Null@@bgcolor[icf,bg[to]],
          t,Fill->"x",TextAnchor->"w",Side->"left"]];i++;
	w[i] = Frame[w[icft1],t,Width->5,Side->"left",
	  Null@@bgcolor[icf,bg[to]]];i++];
      spb=((SpinBox/.spb/.SpinBox->False) === True);
      With[{wsym=If[wv<=>{},wv[[1,2]],w[i]]}, 
        wsym = If[spb,SpinBox,Entry][w[icft1],Null@@bgcolor[icf,co],If[c<=>{},c[[1]]],
          t,Width->ew,Side->"right",(v/.Variable->TextVariable),BD->vdbd,Justify->"right",scol]];i++;

      ,(KBFCheckButton|KACCheckButton)[__],
      If[transparent,
	co=Override[co,BG->Transparent,HighlightBackground->Transparent]];
      newcolumn[n];
      If [t<=>{}&&Head[t[[1,2]]]<=>List,
        If [v<=>{}&&btv,
          If [~RealQ[Variable/.v],
            Evaluate[Extract[v,{1,2},Unevaluated$]]=1;
            ];
          w[i] = Variable/.v;
          lv = Append[lv, Head[#][v[[1]],i]];
          With[{i}, v = {Variable:>w[i]}];i++;
          ];
        With[{wsym=If[wv<=>{},wv[[1,2]],w[i]]}, 
          wsym = CheckButton[w[icf],Null@@bgcolor[icf,co],t,c,v,
            Anchor->"w",TextAnchor->"w",BD->vdbd,Null@@ep]];i++;
        ,!Else
        cl = If [cl<=>{}, cl[[1,2]], 1];
        Block[{rw1,tw,irf1,irf2,it,width,lo,otmp,wtmp,vtmp,hs=Head[#]},
          it = With[{base = InitialIndex/.rem}, If[RealQ[base], base - 1, 0]];
          o = t[[1,2]];
          lo = Length[o];
	  otmp = Map[StringLength, o];
          tw = Max[otmp];
	  width = Width/.rem/.Width->Automatic;
	  width = Switch[width,
	    {},		tw,
	    _List,	MapThread[Switch[#1,
	      Automatic,	#2,
	      Max,		tw,
	      _,		#1]&, {
		Take[Join[width, Table[Last[width], {lo - Length[width]}]], lo], otmp}],
	    _Real,	width,
	    _,		tw];
          rw1 = Floor[lo/cl];
          If [lo - rw1*cl <> 0, rw1++];
          w[i] = Frame[w[icf],Null@@trbg[icf]];irf1=i++;
          Do[
            w[i] = Frame[w[irf1], Fill->"x",Null@@trbg[icf]];irf2=i++;
            otmp = Take[o, {cl*(j-1)+1,Min[cl*j,lo]}];
	    wtmp = Switch[width,
	      _Real,	width,
	      _,	Take[width, {cl*(j-1)+1,Min[cl*j,lo]}]];
            ScanThread[(
              it++;
              If [v<=>{},
                vtmp = With[{x=v[[1,2]],it},{Variable:>x[it]}];
                If [~RealQ[Variable/.vtmp],
                  Evaluate[Extract[vtmp,{1,2},Unevaluated$]]=0;
                  ];
                If [btv,
                  w[i] = Variable/.vtmp;
                  lv = Append[lv, hs[vtmp[[1]],i]];
                  With[{i}, vtmp = {Variable:>w[i]}];i++;
                  ];
                ];
              With[{wsym=If[wv<=>{},wv[[1,2]][it],w[i]],vsym=If[v<=>{},Extract[v,{1,2},Unevaluated$]],it},
                wsym = CheckButton[w[irf2],Null@@bgcolor[irf2,co],
                  Text->#,If[c<=>{},With[{cc=Extract[c,{1,2},Unevaluated$]},
                    If[vsym<=>Null,Command:>(vsym[0]=it;cc),c[[1]]]],Null[]],vtmp,TextAnchor->"w",Side->"left",Width->#2,
                  PadX->1,PadY->0,
                (* PadX->3,PadY->2, K. Oide 2/25/2001 *)
                BD->vdbd]];i++;)&
                  ,{otmp,wtmp}
              ];
            ,{j,rw1}
            ];
          ]; !Block
        ]; !If

      ,(KBFRadioButton|KACRadioButton)[__],
      If[transparent,
	co=Override[co,BG->Transparent,HighlightBackground->Transparent]];
      newcolumn[n];
      If [v<=>{}&&~RealQ[Variable/.v],
        Evaluate[Extract[v,{1,2},Unevaluated$]]=1;
        ];
      If [v<=>{}&&btv,
        w[i] = Variable/.v;
        lv = Append[lv, Head[#][v[[1]],i]];
        With[{i}, v = {Variable:>w[i]}];i++;
        ];
      If [t<=>{},
        With[{twsym=If[twv<=>{},twv[[1,2]],w[i]]},
          twsym = TextLabel[w[icf],t,TextAnchor->"w",Justify->"left",Null@@ep,
	    Fill->"x",Null@@bgcolor[icf,bg[co]]]];i++;
        ];
      it = With[{base = InitialIndex/.rem}, If[RealQ[base], base - 1, 0]];
      cl = If [cl<=>{}, cl[[1,2]], 1];
      If [cl == 1,
        Scan[(
          it++;
          With[{wsym=If[wv<=>{},wv[[1,2]][it],w[i]]}, 
            wsym = RadioButton[w[icf],Null@@bgcolor[icf,co],Text->#,
	      If[vdp,rpad,Null[]],v,
              Value->it,Anchor->"w",TextAnchor->"w",BD->vdbd,c]];i++;)&
                ,o[[1,2]]];
        ,!Else
        Block[{rw1,tw,irf1,irf2,it=0,width,lo,otmp,wtmp},	
          o = o[[1,2]];
          lo = Length[o];
	  otmp = Map[StringLength, o];
          tw = Max[otmp];
	  width = Width/.rem/.Width->Automatic;
	  width = Switch[width,
	    {},		tw,
	    _List,	MapThread[Switch[#1,
	      Automatic,	#2,
	      Max,		tw,
	      _,		#1]&, {
		Take[Join[width, Table[Last[width], {lo - Length[width]}]], lo], otmp}],
	    _Real,	width,
	    _,		tw];
          rw1 = Floor[lo/cl];
          If [lo - rw1*cl <> 0, rw1++];
          w[i] = Frame[w[icf], If[vdp,rpad,Null[]],
            Null@@bgcolor[icf,bg[co]]];irf1=i++;
          Do[
            w[i] = Frame[w[irf1], Fill->"x",
              Null@@bgcolor[irf1,bg[co]]];irf2=i++;
            otmp = Take[o, {cl*(j-1)+1,Min[cl*j,lo]}];
	    wtmp = Switch[width,
	      _Real,	width,
	      _,	Take[width, {cl*(j-1)+1,Min[cl*j,lo]}]];
            ScanThread[(
              it++;
              With[{wsym=If[wv<=>{},wv[[1,2]][it],w[i]]}, 
                wsym = RadioButton[w[irf2],Null@@bgcolor[irf2,co],Text->#,v,
                  Value->it,TextAnchor->"w",BD->vdbd,c,Side->"left",Width->#2]];i++)&
                    ,{otmp,wtmp}
              ];
            ,{j,rw1}
            ];
          ]; !Block
        ]; !If

      ,(KBFOptionMenu|KACOptionMenu)[__],
      If[transparent, to=Override[to,BG->Transparent]];
      If[transparent, co=Override[co,,HighlightBackground->Transparent]];
      newcolumn[n];
      If [v<=>{},
        If [~RealQ[Variable/.v],
          Evaluate[Extract[v,{1,2},Unevaluated$]]=1;
          ];
        If [btv,
          With[{vt=Variable/.v,lo=Length[o[[1,2]]]},
            w[i] = o[[1,2,If[vt<0,1,If[vt>lo,lo,vt]]]];
            ];
          lv = Append[lv, Head[#][v[[1]],i,o[[1,2]]]];
          With[{i}, v = {Variable:>w[i]}];i++
          ,!Else
          If [o<=>{},
            With[{vname=Extract[v,{1,2},Unevaluated$],$prev$=v[[1,2]],i,il=o[[1,2]],lo=Length[o[[1,2]]]},
	      conflict = Switch[If[Depth[Hold[vname]] == 2, Hold[vname],
		Extract[Hold[vname], {1,0}, Hold]],
		Hold[val], True, _, False];
              Clear[vname];
              w[i] = il[[$prev$]];
              vname := (Position[il,w[i]][[1,1]]);
	      If[Not[conflict],
              (vname=val_) ^:= (w[i]=il[[Restrict[val,1,lo]]]),
              (vname=Val_) ^:= (w[i]=il[[Restrict[Val,1,lo]]])];
              v = {Variable:>w[i]};
              ];i++;
            ];
          ];
        ];
      If[t<=>{},With[{twsym=If[twv<=>{},twv[[1,2]],w[i]]}, 
        twsym = TextLabel[w[icf],t,Null@@bgcolor[icf,to],
          TextAnchor->"w",Justify->"left",Null@@ep,Fill->"x"]];i++];
      w[i] = Frame[w[icf],Fill->"x",Null@@bgcolor[icf,bg[to]]];icft1=i++;
      With[{wsym=If[wv<=>{},wv[[1,2]],w[i]]}, 
        wsym = OptionMenu[w[icft1],Null@@bgcolor[icf,co],o,If[vdp,opad,Null[]],(v/.Variable->TextVariable),
          Side->"left",BD->vdbd,BG->KBF$BGColor,ActiveBackground->KBF$ABG,
          ActiveForeground->"black"]];i++;

      ,(KBFButton|KACButton)[__],
      If[transparent,
	co=Override[co,HighlightBackground->Transparent]];
      newcolumn[n];
      If [t<=>{}&&Head[t[[1,2]]]===List,
        cl = If [cl<=>{}, cl[[1,2]], 1];
        Block[{rw1,tw,irf1,irf2,it=0,width,lo,otmp,wtmp},
          o = t[[1,2]];
          lo = Length[o];
	  otmp = Map[StringLength, o];
          tw = Max[otmp];
	  width = Width/.rem/.Width->Automatic;
	  width = Switch[width,
	    {},		tw,
	    _List,	MapThread[Switch[#1,
	      Automatic,	#2,
	      Max,		tw,
	      _,		#1]&, {
		Take[Join[width, Table[Last[width], {lo - Length[width]}]], lo], otmp}],
	    _Real,	width,
	    _,		tw];
          rw1 = Floor[lo/cl];
          If [lo - rw1*cl <> 0, rw1++];
          w[i] = Frame[w[icf],Null@@trbg[icf]];irf1=i++;
          Do[
            w[i] = Frame[w[irf1], Fill->"x", Null@@trbg[icf]];irf2=i++;
            otmp = Take[o, {cl*(j-1)+1,Min[cl*j,lo]}];
	    wtmp = Switch[width,
	      _Real,	width,
	      _,	Take[width, {cl*(j-1)+1,Min[cl*j,lo]}]];
            ScanThread[(
              it++;
              With[{wsym=If[wv<=>{},wv[[1,2]][it],w[i]],vsym=If[v<=>{},Extract[v,{1,2},Unevaluated$]],it}, 
                wsym = Button[w[irf2],Null@@bgcolor[icf,co],
                  Text->#,{If[c<=>{},With[{cc=Extract[c,{1,2},Unevaluated$]},
                    If[vsym<=>Null,Command:>(vsym=it;cc),c[[1]]]]]},Side->"left",Width->#2,
                  PadX->1,PadY->0,
                (* PadX->3,PadY->2, K. Oide 2/25/2001 *)
                BD->vdbd]];i++)&
                  ,{otmp,wtmp}
              ]
            ,{j,rw1}
            ];
          ]; !Block
        ,!Else
        With[{wsym=If[wv<=>{},wv[[1,2]],w[i]]},
          wsym = Button[w[icf],Null@@bgcolor[icf,co],If[vdp,opad,Null[]],t,c,(v/.Variable->TextVariable),
            (* PadY->2, *) PadY->0,BD->vdbd]];i++;
        ];

      ,KBFTextEditor[__],
      newcolumn[n];
      If [t<=>{},
        With[{twsym=If[twv<=>{},twv[[1,2]],w[i]]},
          twsym = TextLabel[w[icf],t,TextAnchor->"w",Justify->"left",Null@@ep,Fill->"x",Null@@trbg[icf]]];i++;
        ];
      w[i] = Frame[w[icf],Fill->"x",If[vdp,lpad,Null[]],Null@@trbg[icf]];icft1=i++;
      w[i] = Frame[w[icft1],Width->10,Side->"left",Null@@trbg[icf]];i++;
      w[i] = Frame[w[icft1],Fill->"x",Null@@trbg[icf]];icft2=i++;
      w[i] = Frame[w[icft1],Fill->"x",Null@@trbg[icf]];icft1=i++;
      w[i] = ScrollBar[w[icft2],Orient->"vertical",Side->"right",Fill->"y",Width->8,BD->vdbd];isv=i++;
      w[i] = Frame[w[icft1],Width->10,Side->"right",Null@@trbg[icf]];i++;
      w[i] = ScrollBar[w[icft1],Orient->"horizontal",Side->"bottom",Fill->"x",Width->8,BD->vdbd];ish=i++;
      With[{wsym=If[wv<=>{},wv[[1,2]],w[i]]},
        wsym = TextEditor[w[icft2],Null@@bgcolor[ifc,co],
          c,BorderWidth->1,PadX->0,PadY->0,Fill->"x",Width->16,Height->8,
          YScrollCommand:>w[isv][Set], XScrollCommand:>w[ish][Set],
          Null@@ep];i++;
        If [v<=>{},
	  If [btv,
	    wsym[Insert] = {"insert", Variable/.v};
	    lv = Append[lv, Head[#][v[[1]],Hold[wsym]]];
	    ,!Else
	    With[{vname=Extract[v,{1,2},Unevaluated$],$prev$=v[[1,2]]},
	      Clear[vname];
	      conflict = Switch[If[Depth[Hold[vname]] == 2, Hold[vname],
	        Extract[Hold[vname], {1,0}, Hold]],
	        Hold[val], True, _, False];
	      vname := wsym[GetText[{"1.0","end"}]][1,-2];
	      If[Not[conflict],
		(vname=val_String) ^:= (
		  wsym[Delete]={"1.0","end"};wsym[Insert]={"insert",val}),
		(vname=Val_String) ^:= (
		  wsym[Delete]={"1.0","end"};wsym[Insert]={"insert",Val})];
	      vname = $prev$;
	      ];
	    ];
	  ];
        ];

      ,(KBFListBox|KACListBox)[__],
      newcolumn[n];
      If [t<=>{},
        With[{twsym=If[twv<=>{},twv[[1,2]],w[i]]}, 
          twsym = TextLabel[w[icf],t,TextAnchor->"w",Justify->"left",Null@@ep,Fill->"x",Null@@trbg[icf]]];i++;
        ];
      w[i] = Frame[w[icf],Fill->"x",If[vdp,lpad,Null[]],Null@@trbg[icf]];icft1=i++;
      w[i] = Frame[w[icft1],Width->10,Side->"left",Null@@trbg[icf]];i++;
      w[i] = Frame[w[icft1],Fill->"x",Null@@trbg[icf]];icft2=i++;
      w[i] = Frame[w[icft1],Fill->"x",Null@@trbg[icf]];icft1=i++;
      w[i] = ScrollBar[w[icft2],Orient->"vertical",Side->"right",Fill->"y",Width->8,BD->vdbd];isv=i++;
      w[i] = Frame[w[icft1],Width->14,Side->"right",Null@@trbg[icf]];i++;
      w[i] = ScrollBar[w[icft1],Orient->"horizontal",Side->"bottom",Fill->"x",Width->8,BD->vdbd];ish=i++;
      With[{isv,ish,wsym=If[wv<=>{},wv[[1,2]],w[i]]},
        wsym = ListBox[w[icft2],Null@@bgcolor[ifc,co],{If[o<=>{}&&o[[1,2]]<=>{},Insert->{"end",o[[1,2]]}]},
          Height->4,SelectMode->"browse",Fill->"x",BD->vdbd,YScrollCommand:>w[isv][Set], XScrollCommand:>w[ish][Set],scol];ilb=i++;
        If [v<=>{}<=>o,
          If [~RealQ[Variable/.v],
            Evaluate[Extract[v,{1,2},Unevaluated$]]=1;
            ];
          wsym[Select$Set] = Variable/.v;
          wsym[YView] = Variable/.v;
          If [btv,
            lv = Append[lv, Head[#][v[[1]],ilb]];
            ,!Else
            With[{vname=Extract[v,{1,2},Unevaluated$]},
	      conflict = Switch[If[Depth[Hold[vname]] == 2, Hold[vname],
		Extract[Hold[vname], {1,0}, Hold]],
		Hold[val], True, _, False];
              Clear[vname];
              vname := wsym[Selection][[1]];
	      If[Not[conflict],
              (vname=val_) ^:= (wsym[Select$Clear]=vname;wsym[Select$Set]=val;wsym[YView]=val),
              (vname=Val_) ^:= (wsym[Select$Clear]=vname;wsym[Select$Set]=Val;wsym[YView]=Val)];
              ];
            ];
          ];
        If[c<=>{},
          With[{cc=Extract[c,{1,2},Unevaluated$]},
            Bind[wsym,"<ButtonRelease-1>",cc];
            ];
          ];
        ];
      w[i] = Frame[w[icft2],Width->100,Side->"bottom",Null@@trbg[icf]];i++;

      ,(KBFCursorEntry)[___],
      If[transparent, to=Override[to,BG->Transparent]];
      newcolumn[n];

      w[i] = Frame[w[icf],Fill->"x",Null@@ep,
	Null@@bgcolor[icf,bg[to]]];icft1=i++;
      If[t<=>{}&&twv<=>{},
	With[{twsym=If[twv<=>{},twv[[1,2]],w[i]]}, 
          twsym = TextLabel[w[icft1],Null@@bgcolor[icf,bg[to]],
            t,Fill->"x",TextAnchor->"w",Side->"left"]];i++;
	w[i] = Frame[w[icft1],t,Width->5,Side->"left",
	  Null@@bgcolor[icf,bg[to]]];i++];
      With[{wsym=If[wv<=>{},wv[[1,2]],w[i]],
	fact$ = Factor/.rem/.(Factor->Null)},
	wsym = CursorEntry[w[icft1],Variable/.Override[rem, v, Variable->0],
	  ForKBFrame->True, Switch[rg, {_Real, _Real}, Range->rg, _, Null[]],
	  If[StringQ[nf], Form->Switch[nf[1],
	    "0"|"1"|"2"|"3"|"4"|"5"|"6"|"7"|"8"|"9", "F"//nf,
	    _, nf], Null[]],
	  If[RealQ[fact$], Factor->fact$, Null[]],
	  If[RealQ[cp], DefaultPosition->cp, Null[]],
	  Width->ew, Null@@c, Null@@bgcolor[icf,co], Null@@scol, Null@@spb];
	wsym@bm[Background] = w[icft1][Background];
	If[wv<=>{}, w[i] = wsym];
	If[v<=>{}, If[btv,
	  lv = Append[lv, Head[#][v[[1]],i]],
	  With[{vname=Extract[v,{1,2},Unevaluated$],i},
	    conflict = Switch[If[Depth[Hold[vname]] == 2, Hold[vname],
	      Extract[Hold[vname], {1,0}, Hold]],
	      Hold[val]|Hold[lo$]|Hold[hi$]|Hold[form$], True, _, False];
	    Clear[vname];
	    vname := wsym@Value[];
	    vname[Range] := wsym@Range[];
	    vname[Form] := wsym@Form[];
	    If[Not[conflict],
	    (vname = val_) ^:= (wsym@SetValue[val]; wsym@Value[]);
	    (vname[Range] = {lo$_Real, hi$_Real}) ^:= wsym@SetRange[lo$, hi$];
	    (vname[Form] = form$_String) ^:= wsym@SetForm[Switch[form$[1],
	      "0"|"1"|"2"|"3"|"4"|"5"|"6"|"7"|"8"|"9", "F"//form$, _, form$]],
	    (vname = Val_) ^:= (wsym@SetValue[Val]; wsym@Value[]);
	    (vname[Range] = {Lo$_Real, Hi$_Real}) ^:= wsym@SetRange[Lo$, Hi$];
	    (vname[Form] = Form$_String) ^:= wsym@SetForm[Switch[Form$[1],
	      "0"|"1"|"2"|"3"|"4"|"5"|"6"|"7"|"8"|"9", "F"//Form$, _, Form$]]];
	    ]]];
	];i++;

      ,(KBFFrame|KACFrame)[___],
      If[transparent, co=Override[co,BG->Transparent]];
      newcolumn[n];
      With[{wsym=If[wv<=>{},Extract[wv,{1,2},Unevaluated$],w[i]]},
        wsym = Frame[w[icf],Null@@bgcolor[icf,co]];
	If[wv<=>{}, w[i]=wsym]];i++;
      If[acomp<=>{},
	With[{ret=KBF$ArrangeComponents[w,i-1,i,acomp[[1,2]],
	  TemporaryVariable->btv, Transparent->transparent,
	  Null@@opt$inherit]},
	  If[btv, i=ret[[1]]; lv=Join[lv, ret[[2]]], i=ret]]];

      ,(KBFFrameTabed)[___],
      If[transparent, co=Override[co,BG->Transparent]];
      newcolumn[n];
      With[{iwsym=i; icfbg=w[icf][Background],
	wsym=If[wv<=>{},Extract[wv,{1,2},Unevaluated$],w[i]]},
	w[icf][Background]=BG/.bgcolor[icf,Override[bg[co], BG->KBF$BGColor]];
        wsym = KBFTabFrame[w[icf],Null@@bgcolor[icf,co]];i++;
	wsym@c[Background]=icfbg;
	w[icf][Background]=icfbg;
	If[acomp<=>{},
	  With[{ret=KBF$ArrangeTabComponents[wsym,w,i,acomp[[1,2]],
	    Null@@First[SwitchCases[rem, {Rule[InitialTab,_]}]],
	    TemporaryVariable->btv, Transparent->transparent,
	    Null@@opt$inherit]},
	    If[btv, i=ret[[1]]; lv=Join[lv, ret[[2]]], i=ret]]];
	If[wv<=>{}, w[iwsym]=wsym]];

      ,(KBFFrameToggled)[___],
      If[transparent, co=Override[co,BG->Transparent]];
      newcolumn[n];
      With[{iwsym=i+1;wsym=If[wv<=>{},Extract[wv,{1,2},Unevaluated$],w[i+1]]},
	w[i] = KBFToggleFrame[w[icf], wsym, Null@@t, Null@@bgcolor[icf,co],
	  Null@@First[SwitchCases[rem, {Rule[InitialState,_]}]]]; i+=2;
	(* Define ToggleFrame Operator: Toggle/Show/Hide *)
	If[wv<=>{},With[{sym=Extract[wv, {1,2}, Unevaluated$], toggle=w[i-2]},
	  WidgetValue[sym, Toggle] := toggle@ChangeState[];
	  WidgetValue[sym, Show] := If[toggle@bst === False,
	    toggle@ChangeState[]];
	  WidgetValue[sym, Hide] := If[toggle@bst <=> False,
	    toggle@ChangeState[]];
	  ]];
	If[wv<=>{}, w[iwsym]=wsym];
	If[acomp<=>{},
	  With[{ret=KBF$ArrangeComponents[w,iwsym,i,acomp[[1,2]],
	    TemporaryVariable->btv, Transparent->transparent,
	    Null@@opt$inherit]},
	    If[btv, i=ret[[1]]; lv=Join[lv, ret[[2]]], i=ret]]];
	];

      ,(KBFComponent|KACComponent)[__],
      If[transparent, co=Override[co,BG->Transparent]];
      newcolumn[n];
      With[{wsym=If[wv<=>{},Extract[wv,{1,2},Unevaluated$],w[i]]},
	wsym = Apply[cn[[1,2]],Prepend[bgcolor[icf,co],w[icf]]]];i++;

      ,(KBFHook)[___], (* Execute Command Hook *)
      newcolumn[n];
      With[{c},	Command/.c];

      ];
    )&,If[Head[add[[1]]]===KBFGroup,add,Prepend[add,KBFGroup[Frame->False]]]];
!  If[icf>0,w[i] = Frame[w[icf],Height->5]];i++;
  If [btv, {i,lv}, i]
  ];
!SetAttributes[KBArrangeComponents,HoldFirst];

KBF$ArrangeTabComponents[TabFrame_, w_, i0_, add_, opt___] := Module[
  {lv={}, i=i0, tablist={},
    acomp, tabname, com, dscom, ex, ipx, anch,
    wv, co, other,
  {sel,btv,transparent} = {InitialTab,TemporaryVariable,Transparent}/.{opt}/.
    {InitialTab->1,TemporaryVariable->False,Transparent->False}},
  Scan[(
    {acomp, tabname, com, dscom, ex, ipx, anch, wv, co, other} =
      SwitchCases[If[#<=>Null,#,{}],{Rule[Add,_], Rule[TabName|Text,_],
	RuleDelayed[Command,_], RuleDelayed[DeselectCommand,_],
	Rule[Expand,_], Rule[IPadX,_], Rule[Anchor,_],
	RuleDelayed[WidgetVariable,_],
	Rule[ComponentOption|WidgetOption,_],
	_}];

    If[tabname<=>{},tabname=tabname[[1,2]]];
    If[co<=>{},co=co[[1,2]]];
    co=Override[co/.((Background->x_)->(BG->x))];

    Switch[#
      ,(KBFTab[___]),
      If[transparent, co=Override[co,BG->Transparent]];
      If[tabname<=>{},
	With[{wsym=If[wv<=>{},Extract[wv,{1,2},Unevaluated$],w[i]]},
	  TabFrame@AddTab[tabname, wsym,
	    Null@@(co/.((BG->Transparent)->(BG->TabFrame@bg))),
	    Null@@Join[com, dscom, ex, ipx, anch]];
	  AppendTo[tablist, tabname];
	  If[wv<=>{}, w[i]=wsym]]; i++;
	If[acomp<=>{},
	  With[{ret=KBF$ArrangeComponents[w,i-1,i,acomp[[1,2]],
	    TemporaryVariable->btv, Transparent->transparent,
	    Null@@Last[SwitchCases[{opt},
	      {Rule[InitialTab|TemporaryVariable|Transparent, _], _}]]]},
	    If[btv, i=ret[[1]]; lv=Join[lv, ret[[2]]], i=ret]]];
	];

      ];
    )&,add];

  sel = Restrict[If[RealQ[sel], Round[sel],
    With[{pos = Position[tablist, sel]}, If[pos <=> 1, pos[[1,1]], {}]]],
    1, TabFrame@nt];

  TabFrame@SelectTab$[sel];

  If [btv, {i, lv}, i]
  ];

Protect[KB$Frame,KBMainFrame,KBSubFrame,KBDialogFrame,KBFComponentFrame];
Protect[ProgressBar,StatusLine,FreeStatusLine,AddsMenuButton,About,RegisterCopy,RegisterSaveAs];

System$Names = Join[System$Names,Complement[Names["*"],KBFrame$Names0]];
KBFrame$Names0=.;

! Execute EvalAfter hook for KBFrame package
PkgHookEvalAfter["KBFrame"];
