Unprotect[Bar,Scale,Tags,Text];
SetAttributes[{Graphics,AspectRatio,PlotRange,
  PlotRegion,PlotLabel,TickSize,Tags,
  PlotJoined,StepRatio,PointSize,PointSymbol,PlotColor,Dashing,
  ErrorBarTickSize,ErrorBarThickness,PointColor,PointBorderColor,PointTags,
  LineTags,Thickness,FrameTicks,Initialize,FrameLabel,DisplayFunction,
  DataRange,Reference,FillColor,Arrow,Clip,
  Orientation,Line,Point,Rectangle,Circle,Polygon,Hook,Linear,Bar,Text,
  TextSize,TextRotate,TextAlign,Scaled,GridLines,WindowScaled,CanvasScaled,
  RectScaled,
  AboveTags,BelowTags,LeftTags,RightTags,
  TextCases,TextPosition,Prolog,Epilog,Vertical,Alignment,Legend,
  Scale,Weight,FrameClick,InfoBind,TickFont,
  Major,Minor,Both,Ticks},Constant];

Graphics$Options=AspectRatio|FrameLabel|PlotRange|GridLines|Alignment|DataRange|
  PlotRegion|PlotLabel|FrameTicks|TickSize|TickFont|Tags|Background|Frame|FrameClick|
    InfoBind;

With[{LP$def={Scale->{Linear,Linear},PlotRange->{Automatic,Automatic},
  AspectRatio->Automatic,PlotJoined->False,StepRatio->1,
  PointSize->1,PointSymbol->"1O",Plot->True,Frame->True,
  PlotColor->"Black",Dashing->{1},Tags->False,TickFont->Default,
  TickSize->Automatic,TickFont->Default,PlotRegion->{{0,1},{0,1}},
  ErrorBarTickSize->1,ErrorBarThickness->1,PointColor->"forest green",
  PointBorderColor->Automatic,GridLines->{Automatic,Automatic},
  PointTags->Null,LineTags->Null,Thickness->1,
  FrameTicks->{True,True,Ticks,Ticks},Initialize->True,
  FrameLabel->{"","","",""},DisplayFunction:>$DisplayFunction,
  PlotLabel->"",Prolog->{},Epilog->{},Legend->False,
  Background->"#ffffff"},
  r=(Rule|RuleDelayed)[Graphics$Options,_]},

  ListPlot[ll_List,opt___]:=Module[
    {ld,d,op=Override[{opt},LP$def],sc,pg,eg,pj,of,in,pr,pl,body,gopt,dr,g,la},
    If[Length[ll]>0,
      d=Length[First[ll]];
      {ld,dr}=Switch[d,
        0,
        {Thread[{Range[Length[ll]],ll}],{{1,Length[ll]},MinMax[ll]}},
        2,
        {ll,MapThread[MinMax,ll]},
        3,
        la=MapAt[Abs,Thread[ll],{3}];
        {Thread[{First[la],Second[la],Table[0,{Length[ll]}],Third[la]}],
          {MinMax[First[la]],
            {Min[Second[la]-Third[la]],Max[Second[la]+Third[la]]}}},
        4,
        la=MapAt[Abs,Thread[ll],{{3},{4}}];
        {ll,
          {{Min[First[la]-Third[la]],Max[First[la]+Third[la]]},
            {Min[Second[la]-la[[4]]],Max[Second[la]+la[[4]]]}}},
        _,
        Message[ListPlot::wrongsize];
        Return[]],
      {ld,dr}={{},{{0,1},{0,1}}}];
    {sc,pg,eg,pj,of,in,pr,pl}={Scale,Prolog,Epilog,PlotJoined,DisplayFunction,
      Initialize,PlotRegion,Plot}/.op;
    sc=Flatten[{Linear,sc}][[{-2,-1}]];
    gopt=Override[Scale->sc,
      Cases[op,r,1],DataRange->dr];
    body=Flatten[
      {pg,
      Switch[pj,
        False,
        Point[ld,SetOption[{PointSize,PointColor,PointSymbol,PlotColor,
          PointBorderColor,
          ErrorBarTickSize,ErrorBarThickness,PointTags,Legend},op]],

        Step|True,
        Line[ld,SetOption[
          {Plot,PointSize,PointColor,PointBorderColor,PointSymbol,PointTags,
	    PlotJoined,StepRatio,Thickness,PlotColor,Dashing,LineTags,
            ErrorBarTickSize,ErrorBarThickness,Legend},op]],

	_, (* Unsupported *)],
      eg}];
    g=Graphics[body,gopt];
    If[of<=>Identity && None<=>of<=>Null,
      Show[g,
        Initialize->in,
        PlotRegion->pr
        ]];
    g]];

SetOption[opts_,r_]:=Thread[opts->(opts/.r)];
!SetOption[opts_,r_]:=Cases[r,p:((Alternatives@@opts)->_),1];

ListPlot::highD="List in 1, 2, or 3D is required";
ListPlot::wrongsize="List of less than 5 reals is required";

RealListQ[x_]:=Head[x]===List && RealQ[Apply[Plus,x]];

WindowBackground=Background;

Show[g__]:=Show1$[True,Automatic,g];

With[{
  def={PlotRange->Automatic,
    PlotRegion->{{0,1},{0,1}},
    DataRange->{{1E100,-1E100},{1E100,-1E100}}},
  def0={PlotRange->Default,
    PlotRegion->{{0,1},{0,1}},
    DataRange->{{1E100,-1E100},{1E100,-1E100}}}},

  Show1$[ini_,rect_,g__]:=Module[
    {{gl,df,init,opt,rem}=SwitchCases[Flatten[{g}],
      {_Graphics,(Rule|RuleDelayed)[DisplayFunction,_],
        (Rule|RuleDelayed)[Initialize,_],
	(_Rule|_RuleDelayed),
	_}],
      pr,dr,prl,drl,pr0,prg},
    gl=Replace[#,{Graphics[x_,y___]:>Graphics[x,Flatten[{y}]]}]&/@gl;
    df=DisplayFunction/.df/.DisplayFunction:>$DisplayFunction/.Default:>$DisplayFunction;
    opt=Override[opt,gl[[1,2]],def0];
    If[df<=>Identity && None<=>df<=>Null,
      If[ini && df===CanvasDrawer,
        The$CanvasObject@AllGraphics={gl,opt}];
      {pr0,prg}={PlotRange,PlotRegion}/.opt;
      prl=Prepend[(PlotRange/.Second[#]/.def0)&/@gl,pr0]/.Default:>Null[];
      pr=If[prl==={},
        {{Automatic,Automatic},{Automatic,Automatic}},
        PR$$[First[prl]]];
      drl=Thread[Partition[Flatten[(DataRange/.Second[#]/.def0)&/@gl],4]];
      dr={{Min[drl[[1]]],Max[drl[[2]]]},{Min[drl[[3]]],Max[drl[[4]]]}};
      opt=Override[{PlotRange->pr,DataRange->dr,PlotRegion->prg},
        opt];
      init=Initialize/.init/.Initialize->True;
      StandardForm[
        df[opt,gl[[1,1]],init,True,rect,Length[gl]==1,ini];
        Do[
          df[Override[opt,gl[[i,2]]],gl[[i,1]],init,False,
            rect,i==Length[gl],ini],
          {i,2,Length[gl]}]]
      ];
    gl
    ]];

PR$$[{x_List,y_List}]:={x,y};
PR$$[{x_,y_List}]:={{x,x},y};
PR$$[{x_List,y_}]:={x,{y,y}};
PR$$[{x_,y_}]:={{Automatic,Automatic},{x,y}};
PR$$[Default]=Default;
PR$$[x_]:={{x,x},{x,x}};

SetAttributes[
  {ListPlot,SetOption,PR$$,
    ListPlotMessage,Show,
    RealListQ,Show1$,Graphics$Options,
    WindowBackground},Constant];
