SetAttributes[{Constant,HoldFirst,HoldAll,HoldRest,HoldNone},Constant];
HoldPattern=Literal;
SetAttributes[{Literal,HoldPattern},{HoldAll,Constant}];

SetAttributes[{Real,String,BuiltinFunction,
  Word,Expression,WordSeparator,ReadNewRecord,
  NullWords,EndOfFile,$Failed,FormatType,
  InputForm,HoldForm,GenericSymbolForm,
  Automatic,Default,
  None,Undefined},
  Constant];

! Protect constant symbols defined by src/tfinitn.f
SetAttributes[{
  StdIn,StdOut,StdErr,
  True,False,I,NaN,INF,Infinity,Pi,E,EulerGamma,
  SpeedOfLight,SIMu0,SIEpsilon0,MKSAMu0,MKSAEpsilon0,
  ElectronCharge,FineStructureConstant,
  ElectronMass,ElectronRadius,ProtonMass,ProtonRadius},
  Constant];

GoldenRatio=(1+Sqrt[5])/2;
Degree=Pi/180;
SetAttributes[{GoldenRatio,Degree}, Constant];

(* Option flags for DynamicLink[] *)
DYNL$LAZY=1;
DYNL$NOW=2;
DYNL$GLOBAL=256;
DYNL$LOCAL=0;
SetAttributes[{DYNL$LAZY,DYNL$NOW,DYNL$GLOBAL,DYNL$LOCAL},Constant];

(* Special handle for for DynamicCall[] *)
DYNL$NEXT=-1;
DYNL$DEFAULT=-2;
DYNL$SELF=-3;
SetAttributes[{DYNL$NEXT,DYNL$DEFAULT,DYNL$SELF},Constant];

(* Fractional unit modifier for PollUnit[] *)
POLL$READ=0;
POLL$WRITE=1/8;
POLL$SPACE=2/8;
SetAttributes[{POLL$READ,POLL$WRITE,POLL$SPACE},Constant];

(* Option flags for TCPShutdown[] *)
SHUT$RD=1;
SHUT$WR=2;
SHUT$RDWR=SHUT$RD|SHUT$WR;
SetAttributes[{SHUT$RD,SHUT$WR,SHUT$RDWR},Constant];

(* Option flags for FileLock[] *)
Lock$NonBlock=4;
Lock$Test=0;
Lock$Shared=1;
Lock$Exclusive=2;
Lock$Release=3;
SetAttributes[{Lock$NonBlock,Lock$Test,Lock$Shared,Lock$Exclusive,Lock$Release},Constant];

(* Option flags for Wait4[] *)
WNOHANG=1;
WUNTRACED=2;
WCONTINUED=4;
SetAttributes[{WNOHANG,WUNTRACED,WCONTINUED},Constant];

(* Probably it is better to place Context as early as possible. *)
ToContext[`x_]:=x;
ToContext[x_String]:=ToExpression[x];
$ContextStack={`};
$PackageStack={{`,System`}};
$Context=`;
$ContextPath={`,System`};
($Context=`a_)^:=With[{`b=Check[$SetContext[`a],$Context]},$Context:=`b];
($Context=`a_String)^:=
  With[{`b=Check[$SetContext[ToExpression[`a]],$Context]},
    $Context:=`b];
($ContextPath=a_)^:=With[
  {`b=Check[$SetContextPath[ToContext/@a],$ContextPath]},
  $ContextPath:=`b];

Begin[a_]:=With[{`c=$Context,`b=Check[$SetContext[a],Return[]]},
  AppendTo[$ContextStack,`c];$Context:=`b];
End[___]:=With[{b=$SetContext[Last[$ContextStack]]},
  If[Length[$ContextStack]>1,$ContextStack=Drop[$ContextStack,-1]];
  $Context:=b];
BeginPackage[a__]:=With[{`c=$ContextPath,
  `b=Check[$SetContextPath[{a,System`}],Return[]]},
  AppendTo[$PackageStack,`c];`b];
EndPackage[___]:=($SetContextPath[Last[$PackageStack]];
  If[Length[$PackageStack]>1,$PackageStack=Drop[$PackageStack,-1]];
  $ContextPath);
SetAttributes[{Begin,End,BeginPackage,EndPackage,ToContext,Wrap},Constant];

(* Signal numbers for Kill[] *)
SIGHUP=1;
SIGINT=2;
SIGQUIT=3;
SIGILL=4;
SIGTRAP=5;
SIGABRT=6;
SIGIOT=SIGABRT;
SIGEMT=7;
SIGFPE=8;
SIGKILL=9;
SIGBUS=10;
SIGSEGV=11;
SIGSYS=12;
SIGPIPE=13;
SIGALRM=14;
SIGTERM=15;
SIGURG=16;
SIGSTOP=17;
SIGTSTP=18;
SIGCONT=19;
SIGCHLD=20;
SIGTTIN=21;
SIGTTOU=22;
SIGIO=23;
SIGXCPU=24;
SIGXFSZ=25;
SIGVTALRM=26;
SIGPROF=27;
SIGWINCH=28;
SIGINFO=29;
SIGUSR1=30;
SIGUSR2=31;
SIGTHR=32;
SIGLWP=SIGTHR;
SetAttributes[{SIGHUP,SIGINT,SIGQUIT,SIGILL,SIGTRAP,SIGABRT,SIGIOT,SIGEMT,
  SIGFPE,SIGKILL,SIGBUS,SIGSEGV,SIGSYS,SIGPIPE,SIGALRM,SIGTERM,SIGURG,SIGSTOP,
  SIGTSTP,SIGCONT,SIGCHLD,SIGTTIN,SIGTTOU,SIGIO,SIGXCPU,SIGXFSZ,SIGVTALRM,
  SIGPROF,SIGWINCH,SIGINFO,SIGUSR1,SIGUSR2,SIGTHR,SIGLWP},Constant];

If[FBoundQ$[SigAction$],
  (* SigAction Flags *)
  SA$ONSTACK=1;
  SA$RESTART=2;
  SA$RESETHAND=4;
  SA$NOCLDSTOP=8;
  SA$NODEFER=16;
  SA$NOCLDWAIT=32;
  SA$SIGINFO=64;
  SetAttributes[{SA$ONSTACK,SA$RESTART,SA$RESETHAND,
    SA$NOCLDSTOP,SA$NODEFER,SA$NOCLDWAIT,SA$SIGINFO}, Constant];

  (* Signal handler *)
  SigAction$Cmd[_] := Null;
  SigAction$IDs = {};
  $SignalAction[act_, opt___] := With[{$c = SigAction$Cmd[act]},
    If[Head[$c] === RuleDelayed, Action[opt]/.$c]; Null];
  Protect[SigAction$Cmd, SigAction$IDs, $SignalAction];

  (* SigAction$Clean/Cmd* helper functions		*)
  (* MUST be called in ``Signal Critical Section''	*)
  SigAction$Clean[] := (		(* Clear All *)
    Unprotect[SigAction$Cmd, SigAction$IDs];
    Scan[(SigAction$Cmd[#]=.)&, SigAction$IDs];
    SigAction$IDs = {};
    Protect[SigAction$Cmd, SigAction$IDs]);
  SigAction$CmdR[`i_Real] := (	(* Reset Command *)
    Unprotect[SigAction$Cmd];
    SigAction$Cmd[`i]=.;
    Protect[SigAction$Cmd]);
  SigAction$CmdM[`i_Real] := (	(* Mark Command *)
    Unprotect[SigAction$IDs];
    AppendTo[SigAction$IDs, `i];
    Protect[SigAction$IDs]);
  Protect[SigAction$Clean, SigAction$CmdR,  SigAction$CmdM];

  (* SigAction wrapper *)
  SigAction[`argv___] := Module[{`cmd, `act, `opt, `arg, `mask, `id, `ret},
    {cmd, act, opt, arg} = SwitchCases[{argv},
      {RuleDelayed[Action, _], Rule[Action, _], _Rule|_RuleDelayed, _}];

    If[cmd <=> {},
      mask = SigProcMask[Block, AllSignals]; (* Enter Signal Critical Section *)
      id = 1; While[SigAction$Cmd[id] <=> Null, id += 1];
      Unprotect[SigAction$Cmd];
      SigAction$Cmd[id] = cmd[[1]];
      Protect[SigAction$Cmd];
      SigProcMask[Set, mask];		     (* Leave Signal Critical Section *)
      act = {Action->id}];

    SigAction$[Null@@`arg, Null@@act, Null@@opt]];
  Protect[SigAction]];

(* BuildInfo[] *)
$SourceRevision = BuildInfo["Source:Revision"];
$SourceDate = BuildInfo["Source:Date"];
$BuiltDate = BuildInfo["Built:Date"];
$MachineArch = BuildInfo["Target:MACH_ARCH"];
SetAttributes[{$SourceRevision, $SourceDate, $BuiltDate, $MachineArch},
  {Constant}];

(* Execve frontend *)
Execvpe[`file_String, {`argv___String}, {`env___String},
  `opt:((_Rule|_RuleDelayed)...)] := (If[StringPosition[file, "/"] === {},
    Scan[If[FileQ[#//"/"//file],
      Execve[#//"/"//file, {argv}, {env}, opt]]&,
      With[{path = Environment["PATH"]},
	If[path === "", {"/bin", "/usr/bin"},
	  Map[path[#[[1]] + 1, #[[2]] - 1]&,
	    Partition[Flatten[{0, StringPosition[path, ":"], 0}], 2]]]]],
    Execve[file, {argv}, {env}, opt]]; Null);

Execvp[`file_String, {`argv___String},
  `opt:((_Rule|_RuleDelayed)...)] := Execvpe[file, {argv}, Environments[], opt];

(* Save Command Path, Arguments & Environments for ReExec[] *)
ReExec$Env = Environments[];
ReExec$Dir = GetDirectory[];
ReExec$Path = With[{exe = GetEnv["SAD_EXE"]},	(* StringQ is not defined yet *)
  If[Head[exe] === String && StringLength[exe] > 0, exe,
    StringJoin[BuildInfo["Target:SAD_ARCH_ROOT"], "/", $MachineArch, "/",
      "bin/sad1.exe"]]];
With[{cmd = ReExec$Path, argv = $GetCommandLine[]},
  If[Length[argv] > 1 && argv[[1]] === "-c",
    ReExec$Argv = Drop[argv, 2]; ReExec$Arg0 = {cmd, "-c", argv[[2]]},
    ReExec$Argv =      argv;     ReExec$Arg0 = {cmd}]];
SetAttributes[{ReExec$Env, ReExec$Dir, ReExec$Path,
  ReExec$Argv, ReExec$Arg0},Constant];
ReExec[] := ReExec[ReExec$Argv];
ReExec[argv__String] := ReExec[{argv}];
ReExec[argv_List] := (SetDirectory[ReExec$Dir];
  Execve[ReExec$Path, Join[ReExec$Arg0, argv], ReExec$Env,
    ForceCloseOnExec->True, CloseStd->False]);
Protect[ReExec];

$CommandLine=Module[{`s=$GetCommandLine[]},
  Which[
    s==={},
    {},
    s[[1]]==="*" || s[[1]]==="-c",
    Rest[s],
    True,
    s]];

NPARA=Max[1, Check[Switch[BuildInfo/@{"Target:OS_TYPE", "Target:OS_NAME"},
  {"Linux", _},		Get["!/bin/grep ^processor /proc/cpuinfo | /usr/bin/wc -l"],
  {_, "Darwin"},	Get["!/usr/sbin/sysctl -n hw.ncpu"],
  {"4.4BSD-Lite", _},	Get["!/sbin/sysctl -n hw.ncpu"],
  _,			0], 0]];

AutoLoad[`x__,`f_]:=(Scan[
  Function[`a,`a:=(Unprotect[x];Clear[x];Get[f];`a)],{x}];
  Protect[x]);
AutoLoadSet[`x__,`f_]:=(Scan[
  Function[a,`a:=(Unprotect[x];Clear[x];Get[f];`a);
    (`a=`b_)^:=(Unprotect[x];Clear[x];Get[f];`a=`b);
    (`a:=`b_)^:=(Unprotect[x];Clear[x];Get[f];`a:=`b)],{x}];
  Protect[x]);
SetAttributes[{AutoLoad,AutoLoadSet},{HoldAll,Constant}];

PackagesDirectory=GetEnv["SAD_PACKAGES"];
If[PackagesDirectory=="",PackagesDirectory=GetEnv["SAD$PACKAGES"]];
If[PackagesDirectory=="",PackagesDirectory=BuildInfo["Target:SAD_PKG_ROOT"]];
If[PackagesDirectory=="",PackagesDirectory="/SAD/share/Packages/"];
If[PackagesDirectory[-1]<=>"/",PackagesDirectory=PackagesDirectory//"/"];

Get[PackagesDirectory//"PkgConfig.n"];		(* Load PkgConfig/PkgHook function family *)

Get[PackagesDirectory//"MessageName.n"];

($Line=`x_Real)^:=Module[{`n=Max[0,`x]},
  Unprotect[$Line,Out];
  Do[Out[`i]=.;MessageList[`i]=.,{`i,`n+1,$Line}];
  $Line:=Evaluate[`n];
  Protect[$Line,Out];
  `x];
Protect[$Line,Out];

$MessageLast=Null;
$MessageList={};
$MessageCount[_]=0;
MessageList[_]={};
Add$Message[`l_]:=With[{`c=++$MessageCount[Second[`l]]},
  $MessageLast=ReplacePart[Hold@@Delete[`l/.Hold[MessageString[`t_,`a___]]->Null[`a],3],Null,{2,0}];
  If[~MemberQ[$MessageList,Second[`l]], AppendTo[$MessageList,Second[`l]]];
  Which[
!! Disabling evaluation abort due to ``too many Messages'',
!! because $MessageCount is not reseted during TkEventLoop[].
!! Network server service program ``with error handling''
!! is affected by evaluation abort due to Message by network communication errors.
!    `c>=32,	9999,
    `c >12,	First[`l],
    `c==12,	(
      Print["???",Third[`l], ":  Further output of this message will be suppressed."];
      First[`l]),
    True,	{,,Third[`l],ReleaseHold[`l[[4]]]}]];
Set$MessageList:=(
  If[$MessageList<=>{},MessageList[$Line]=$MessageList];
  $MessageList={};
  Clear[$MessageCount];
  $MessageCount[_]=0;);
Check$Message[_,`e__]:=Module[
  {{`le,`lr}=SwitchCases[$MessageList,{Alternatives@@Hold/@Hold[`e],_}]},
  If[`le<=>{},$MessageList=`lr;True,False]];
SetAttributes[Check$Message,HoldAll];

SetAttributes[{Off,On},HoldAll];
Off[`a_::`b_]:=(`a::`b=Flatten[$Off[`a::`b]];);
Off[`x_]:=Hold[`x];
Off[`x__]:=Scan[Off,Hold[`x]];
On[`a_::`b_]:=If[Head[`a::`b]===$Off,`a::`b=First[`a::`b]];
On[`x_]:=Hold[`x];
On[`x__]:=Scan[On,Hold[`x]];

SetAttributes[MessageString,HoldRest];
MessageString[`a_]:=`a;
MessageString[`a_,`arg__]:=StandardForm[With[{`al=List@@With[{`pw=PageWidth/2},
  If[StringLength[#]>`pw,#[1,`pw-4]//" ...",#]&/@ToString[#,HoldForm]&/@Hold[`arg]]},
  StringReplace[`a,MapThread["`"//#1//"`"->#2&,{Range[Length[`al]],`al}]]]];
SetAttributes[Message,HoldAll];
Message[`level_:9,`a_::`b_,`arg___]:=Module[
  {`l=Add$Message[{`level,Hold[`a::`b],ToString[`a::`b,HoldForm],
    Hold[MessageString[`a::`b,`arg]]}],
    `f=$FORM},
  If[Head[`l]===List,
    $ErrorCount++;
    $FORM="";
    Print["???",Third[`l],":  ",`l[[4]]];
    $FORM=`f];
  Which[
    `level<10,,
    `level<1000,Abort[-2],
    `level<10000,Abort[-3]]
  ];

SetAttributes[{Add$Message,Set$MessageList,Check$Message,MessageString,
  On,Off,$Off,Message},Constant];

Sequence=Null;
Protect[Sequence];

Priority[x_]:=($Priority=True;
  Check[x,];
  $Priority=False);
WithPriority[x_,`y_]:=With[x,
  $Priority=True;
  Check[y,];
  $Priority=False];
SetAttributes[{Priority,WithPriority},{HoldAll,Constant}];

Close[`lun_]:=Close$[`lun];
Close[`lun_List]:=Scan[Close, `lun];
Close[`lun1_, `luns__]:=Scan[Close, {`lun1, `luns}];
SetAttributes[Close,Constant];

Shared[`n_Real]:=ReadShared[n];
(Shared[`n_Real] =`v_)^:=WriteShared[n,v];
(Shared[`n_Real]:=`v_)^:=WriteShared[n,Unevaluated$[v]];
(* Use weak typed Shared[`n_] reference in order to capture *)
(* unevaluated term of AddTo, SubstractBy, etc *)
(Shared[`n_]+=`v_)^:=With[{x=ReadShared[n]+Unevaluated$[v]},
  WriteShared[n,x];x];
(Shared[`n_]-=`v_)^:=With[{x=ReadShared[n]-Unevaluated$[v]},
  WriteShared[n,x];x];
(Shared[`n_]*=`v_)^:=With[{x=ReadShared[n]*Unevaluated$[v]},
  WriteShared[n,x];x];
(Shared[`n_]/=`v_)^:=With[{x=ReadShared[n]/Unevaluated$[v]},
  WriteShared[n,x];x];
(Shared[`n_]++)^:=With[{x=ReadShared[n]},
  WriteShared[n,x+1];x];
(Shared[`n_]--)^:=With[{x=ReadShared[n]},
  WriteShared[n,x-1];x];
(++Shared[`n_])^:=With[{x=ReadShared[n]+1},
  WriteShared[n,x];x];
(--Shared[`n_])^:=With[{x=ReadShared[n]-1},
  WriteShared[n,x];x];

CloseShared[`lun_]:=CloseShared$[`lun];
CloseShared[`lun_List]:=Scan[CloseShared, `lun];
CloseShared[`lun1_, `luns__]:=Scan[CloseShared, {`lun1, `luns}];
SetAttributes[CloseShared,Constant];

$WildCardID=0;
$WildCard:=Switch[$WildCardID,
  0,"SAD",
  1,"RegExp",
  _,"Unknown: "//$WildCardID];
($WildCard=`s_)^:=(
  $WildCardID=Switch[ToLowerCase[ToString[s]],
    "regexp",1,
    "sad",0,
    _,Message[$WildCard::unknown,s];$WildCardID]);
Protect[$WildCard];

$SortMethodID=1;
$SortMethod:=Switch[$SortMethodID,
  0,"Quick",
  1,"Merge",
  _,"Unkown: "//$SortMethodID];
($SortMethod=`s_)^:=(
  $SortMethodID=Switch[ToLowerCase[ToString[s]],
  "quick",0,
  "merge",1,
  _,Message[$SortMethod::unknown,s];$SortMethodID]
  )
Protect[$SortMethod];

Label[]:=Label;
SetAttributes[Label,HoldAll];
Log2$[10,x_]:=Log[x]/Log[10];
Log2$[b_,x_]:=Log[x]/Log[b];
Gamma[x_]:=Factorial[x]/x;
Gamma[0,x_]:=Gamma0[x];
Gamma[a_,x_]:=GammaRegularized[a,x]*Factorial[a]/a;
LogGamma[x_]:=LogGamma1[x]-Log[x];
Names[x_]:=Names$[x];
RotateRight[a_,n_]:=RotateRight1[Unevaluated$[a],n];
RotateRight[a_]:=RotateRight1[Unevaluated$[a]];
RotateRight[a_,{`n1_,`n2__}]:=RotateRight[#,{n2}]&/@
  RotateRight1[Unevaluated$[a],n1];
RotateRight[a_,{n1_}]:=RotateRight1[Unevaluated$[a],n1];
RotateLeft[a_,n_]:=RotateRight[Unevaluated$[a],-n];
RotateLeft[a_]:=RotateRight1[Unevaluated$[a],-1];
Union[x__,SameTest->`f_]:=Union1[Join[Unevaluated$[x]],Unevaluated$[f]];
Union[x__,SameTest:>`f_]:=Union1[Join[Unevaluated$[x]],Unevaluated$[f]];
Union[x__]:=Union1[Join[Unevaluated$[x]]];
MatrixQ[x_]:=Length[Dimensions[x]]==2&&Select[x,~VectorQ[#]&,1]=={};
MatrixQ[x_,`t_]:=Length[Dimensions[x]]==2&&Select[x,~VectorQ[#,t]&,1]=={};
SetAttributes[MatrixQ,HoldRest];
Count[x__]:=Length[Position[x]];
MemberQ[l_,`p_]:=Position[l,p,1,1]<=>{};
MemberQ[l_,`p_,`lev_]:=Position[l,p,lev,1]<=>{};
FreeQ[f_,p_]:=
  Position[Unevaluated$[f],Unevaluated$[p],{0,Infinity},1]==={};
FreeQ[f_,p_,lev_]:=
  Position[Unevaluated$[f],Unevaluated$[p],lev,1]==={};
Nest[f_,x_,n_]:=Module[{`y=x},Do[`y=f[y],{n}];y];
NestList[f_,x_,n_]:=Module[{y=x,l={x}},Do[y=f[y];AppendTo[l,y],{n}];l];
Fold[f_,x_,e_]:=Module[{y=x},Do[y=f[`y,e[[i]]],{i,Length[e]}];y];
FoldList[f_,x_,e_]:=Module[{`y=x,l={x}},
  Do[y=f[y,e[[i]]];AppendTo[l,y],{i,Length[e]}];l];
For[`ini_,`cond_,`incr_,`body_]:=(ini;While[cond,body;incr];);
SetAttributes[For,HoldAll];
Through[p_[f__][x__]]:=p@@(#[x]&/@{f});
Positive:=#>0&;
Negative:=#<0&;
NonNegative:=#>=0&;
NonPositive:=#<=0&;
IntegerQ:=(#==Floor[#])&;
Subtract:=(#1-#2)&;
Divide:=(#1/#2)&;
Xor:=(#&&~#2)||(~#&&#2)&;

SetAttributes[{Union,
  MatrixQ,Count,MemberQ,FreeQ,Nest,NestList,Fold,FoldList,For,IntegerQ,
  RotateRight,RotateLeft,Positive,Negative,NonNegative,NonPositive,
  Through,
  Subtract,Divide,Xor,Label,Log2$,Gamma,LogGamma,Names},
  Constant];

HeldPart[x_,n__]:=Extract[x,{n},Hold];
f_[a___,Unevaluated[b__],`c___]^:=f@@Unevaluated$[{a,b,c}];
SetAttributes[Unevaluated,HoldAll];
Evaluate[x__]:=x;
f_[a___,Evaluate[b__],c___]^:=With[{b},f[a,b,c]];
Protect[ReleaseHold,HeldPart,Unevaluated,Evaluate];

StringQ[x_]:=(Head[x]===String);
Characters[x_]:=FromCharacterCode/@ToCharacterCode[x];
StringDrop[x_,{n_}]:=x[1,n-1]//x[n+1,-1];
StringDrop[x_,n_?((#<0)&)]:=x[1,n-1];
StringDrop[x_,n_]:=x[n+1,-1];
StringDrop[x_,{n1_,n2_}]:=x[1,n1-1]//x[n2+1,-1];
StringDrop[x_,{n1_,-1}]:=x[1,n1-1];
StringInsert[x_,y_,n_]:=x[1,n-1]//y//x[n,-1];
StringInsert[x_,y_,n_List]:=
  StringJoin@@Flatten[Thread[{
    MapThread[x,{Prepend[n,1],Append[n-1,-1]}],
    Append[Table[y,{Length[n]}],""]}]];

Timing[f_]:=MapAt[#+TimeUsed[]&,{-TimeUsed[],f},1];
SetAttributes[Timing,HoldAll];

Protect[StringQ,Characters,StringDrop,StringInsert,Timing];

SymbolNameRoot[x_]:=Module[{n=SymbolName[x],p},
  If[(p=StringPosition[n,"$"])<=>{},
    If[StringPosition[n[p[[-1,1]]+1,-1],"{^0123456789}"]==={},
      n[1,p[[-1,1]]-1],n],
    n]];
Protect[SymbolNameRoot];

Vectorize[a___,Vector[x_],b___]^:=Vectorize[a,Vector$[x],b];
ReleaseVector[Vector[{x___}]]^:={x};
f_[a___,Vector[x_],b___,Vector[y_],`c___]^:=
  Vectorize[f,a,Vector$[x],b,Vector$[y],c];
f_[a___,Vector[x_],b___]^:=(Vectorize[f,a,Vector$[x],b]);
Protect[Vector];

$FORM=" ";
$Input=$Output=-1;
(Environment[x_]=s_)^:=SetEnv[x,s];
Environment[x_,s_]:=SetEnv[x,s];
Environment[x_]:=GetEnv[x];
Environment$[x_]:=GetEnv[x];
HomeDirectory[]:=GetEnv["HOME"];
(Directory[]=s_)^:=SetDirectory[s];
Directory[s_]:=SetDirectory[s];
Directory[]:=GetDirectory[];
$MachineName=Environment$["HOST"];
$MachineType=Environment$["MACHTYPE"];
$System=$OperatingSystem=Environment$["OSTYPE"];
Protect[$Input,$Output];
SetAttrubutes[{Environment,Environment$,HomeDirectory,
  $MachineName,$MachineType,$System,$OperatingSystem},Constant];

InitLINE$P[] := (
  Clear[LINE$P];
  LINE$P[`elm_String] := With[{`all = LINE["NAME", "@*"]},	(* Lazy initialize *)
    LINE$P[Clear] := InitLINE$P[];				(* Cache clear singleton *)
    LINE$P["*"] = Range[Length[`all]];
    ScanThread[(LINE$P[#1] = {#2})&, {`all, LINE$P["*"]}];
    LINE$P[`elm$_String] := (
      LINE$P[`elm$] = Flatten[{LINE["POSITION", "@"//`elm$]}]);
    LINE$P[`elm]];
  Null);
InitLINE$P[];
PkgHookAdd["FFS/BeamLineChanged", LINE$P[Clear]];

(Element[x_List,y_,`op___]=`z_List)^:=
  (ScanThread[Function[{a,b},Element[a,y,op]=b],{x,z}];
    z);
(Element[x_,y_String,`op___]=`z_)^:=
  Module[{`k=ToUpperCase[x],`d=Element$["DEFAULT",y,op]},Switch[k,
    "GEO"|"SIGZ",	(Element$[k,y,op]=z),

    "VALUE"|d,		(Element$[d,y,op]=z*LINE["DK",y];
      Scan[(LINE[d,#]=z*LINE["DK",#])&,Flatten[{LINE["POSITION",y//".*"]}]]),

    _,			(Element$[k,y,op]=z;
      Scan[(LINE[k,#]=z             )&,Flatten[{LINE["POSITION",y//".*"]}]])];
    z];
(Element[x_,y_List,op___]=z_List)^:=(
  ScanThread[Function[{a,b},Element[x,a,op]=b],{y,z}];z);
(Element[x_,y_List,op___]=z_)^:=(Scan[Function[{a},Element[x,a,op]=z],y];z);
(Element[x_,y_,op___]=z_)^:=
  With[{n=Element$["NAME",y]},Element[x,n,op]=z];
Element[x___]:=Element$[x];
SetElement[x_?(Element["POSITION",#]<=>{}&),t:(_String|),k__]:=
  Module[{v=SetElement$[x,t,k]},
    Scan[(Element[#[[1]],x]=#[[2]])&,Flatten[{k}]];
    v];
SetElement[x__]:=SetElement$[x];
ExternalMap[___]:=Null;
Protect[Element,SetElement,InitLINE$P];

FFS$SingleParameterCommands={
  AXI,BXI,AYI,BYI,EXI,EPXI,EYI,EPYI,
  R1I,R2I,R3I,R4I,DXI,DPXI,DYI,DPYI,DZI,DDPI,
  SEED,MAXI,FITP,
  axi,bxi,ayi,byi,exi,epxi,eyi,epyi,
  r1i,r2i,r3i,r4i,dxi,dpxi,dyi,dpyi,dzi,ddpi,
  seed,maxi,fitp};
Scan[With[{`v=#},(v=x_)^:=Module[{y=x},
    FFS[v//" "//ToString[Unevaluated[y]]];x]]&,
  FFS$SingleParameterCommands];
FFS$Interrupt=3;
FFS$InterruptMask=0;
SetAttributes[Evaluate[FFS$SingleParameterCommands],Constant];

$TrackParticlesMinTask=80000;

ARRAY[x__]:=Table[0,Evaluate[##]]&@@List/@{x};
Len[x_]:=StringLength[x];
Protect[ARRAY,Len];

DateString$::use="Use DateString[] instead of DateString.";
f_?(Switch[#,FFSFlag|Definition|Unprotect|Clear|SetDelayed,False,_,True]&)[a___,DateString,b___]^:=((* Message[DateString$::use];*)f[a,DateString$[],b]);
DateString[x___]:=DateString$[x];
SetAttributes[{StandardForm,DateString},Constant];

TimeZoneOffset = +540;	(* SAD Default TimeZone: Asia/Tokyo[JST] *)
(TimeZoneOffset = tz_) ^:= SetTimeZone[tz];
Protect[TimeZoneOffset];
Check[SetTimeZone[Get["!date +\\\"%Z\\\""]], SetTimeZone[Get["!date +\\\"%z\\\""]]];	(* Switch to Local TimeZone *)

MkSecureTemp[template_String:Null, op___Rule]:=Module[{prefix, suffix, dir},
  {prefix, suffix, dir} = SwitchCases[Join[{op}, {}],
    {Rule[Prefix, _String], Rule[Suffix, _String], Rule[Directory, _String]}];
  prefix = If[StringQ[template], template,
    StringJoin[If[dir <=> {}, dir[[1, 2]], Environment["TMPDIR"]/.""->"/tmp"],
      "/", If[prefix <=> {}, prefix[[1, 2]], "mkstemp"], ".XXXXXXXXXX"]];
  suffix = If[suffix <=> {}, "."//suffix[[1, 2]], ""];
  MkSecureTemp$[prefix, suffix]];
Protect[MkSecureTemp];

(* BinaryIOQ/UnbufferedIOQ *)
BinaryIOQ[] := Module[{`in, `out, `lout, `lin, `s},
  Check[{in, out} = Pipe[], Return[False]];
  lout = FromCharacterCode[Range[0, 255]]//"LF\nCR\rCRLF\r\nLFCR\n\r";
  WriteString[out, lout]; Close[out];
  lin = Table[If[(s = Read[in, Byte]) === EndOfFile, Break[], s], {Infinity}];
  Close[in]; lout === FromCharacterCode[lin]];

UnbufferedIOQ[] := Module[{`in, `out, `lout, `lin, `s},
  Check[{in, out} = Pipe[], Return[False]];
  lout = "Test"//ToString[Range[10]]//"Vector";
  WriteString[out, lout]; Close[out];
  If[SelectUnit[in, 0] <> StringLength[lout], Return[False]];

  lin = "";
  While[SelectUnit[in, 0] == StringLength[lout] - StringLength[lin],
    If[(s = Read[in, Byte]) === EndOfFile, Break[]];
    lin = lin//FromCharacterCode[s]];

  If[lout === lin && SelectUnit[in, 0] == 0 && Read[in, String] === EndOfFile,
    Close[in]; True, Close[in]; False]];

Protect[BinaryIOQ,UnbufferedIOQ];

(* BidirectionalPipe *)
BDPipe[`argv___] = BidirectionalPipe[argv];	(* Alias *)

BidirectionalPipe[`cmd_String, `argv___String,
  `opt:((_Rule|_RuleDelayed)...)] := BidirectionalPipe[cmd, {argv}, opt];

BidirectionalPipe[`cmd_String, {`argv___String},
  `opt:((_Rule|_RuleDelayed)...)] := Module[{`env, `pid, `op, `p1, `p2, `$pid},
    {env, pid, op} = SwitchCases[Override[opt, ForceCloseOnExec->False],
      {Rule[Environment|Environments, {___String}], RuleDelayed[PID, _], _}];
    env = If[env <=> {}, env[[1,2]], Environments[]];

    Check[p1 = Pipe[],
      Message[9, System::error, "Cannot create pipe"]; Return[$Failed]];
    Check[p2 = Pipe[],
      Message[9, System::error, "Cannot create pipe"]; Return[$Failed]];

    Switch[$pid = Fork[],
      -1, ( (* Error *)
	Message[9, System::error, "Cannot fork process"];
	Return[$Failed]),

      0,  ( (* Child *)
	Check[SetLUN2FD[p1[[1]], 0], Exit[127]];
	Check[SetLUN2FD[p2[[2]], 1], Exit[127]];
	Close/@p1; Close/@p2;

	(* Force activate SIGPIPE *)
	SigAction[SIGPIPE, Action->Default];
	SigProcMask[UnBlock, SIGPIPE];

	If[{argv} === {},
	  Execvpe[cmd, {cmd},  env, Null@@op],
	  Execvpe[cmd, {argv}, env, Null@@op]];
	Exit[127]),

      _,  ( (* Parent *)
	If[pid <=> {},
	  With[{PID = Extract[pid, {1,2}, Unevaluated$]}, PID = $pid]];
	Close[p1[[1]]]; Close[p2[[2]]])];

    {p2[[1]], p1[[2]]}];
Protect[BidirectionalPipe, BDPipe];

(* BoundQ *)
SetAttributes[{BoundQ$, MemberBoundQ$, BoundQ, FBoundQ}, HoldAll];

BoundQ$[`s_] := Switch[Unevaluated[`s],	(* BoundQ without Member[___] *)
  _Real,	True,		(* Rescue system constant symbols *)
  _String,	True,		(* Rescue system constant symbols *)
  {___String},	True,		(* Rescue system constant symbols *)

  _Symbol, Or[FBoundQ$[`s],	(* Test built-in function symbol table *)
    And[Depth[?`s] > 3,		(* Test symbol definition table *)
      With[{`def = List@@Hold/@First[Hold@@[?`s, {1}]]},
	Length[`def] > 1 || UnsameQ@@Hold/@First[Hold@@[`def[[1]],{1}]]],
      Null[]]],

  _,		False];

MemberBoundQ$[`s_] := Switch[Unevaluated[`s],
  Member[_, _], Module[{`memberQ, `left, `right},
    `left  = Extract[Unevaluated[`s], {1}, Hold];
    `right = Extract[Unevaluated[`s], {2}, Unevaluated];
    {`memberQ, `left} = Switch[`left,
      Hold[_Member],	MemberBoundQ$@@`left,
      Hold[_Symbol],	{BoundQ$@@`left, Null@@`left},
      _,		{False, $Failed}];
    With[{`left, `right}, If[Not[`memberQ], {False, $Failed},
      With[{`next = ResolveMember[`left, `right]},
	Switch[Unevaluated[`next],
	  _ResolveMember,	{False, $Failed},
	  _,			{BoundQ$[`next], Unevaluated[`next]}]]]]],

  _, {False, $Failed}];

BoundQ[`s_] := Switch[Unevaluated[`s],
  Member[_, _],	First[MemberBoundQ$[`s]],

  _,		BoundQ$[`s]];

FBoundQ[`s_] := Switch[Unevaluated[`s],
  Member[_, _], Module[{`memberQ, `symbol},
    {`memberQ, `symbol} = MemberBoundQ$[`s];
    And[`memberQ, With[{`symbol}, FBoundQ[`symbol]]]],

  _Symbol, Or[FBoundQ$[`s],	(* Test built-in function symbol table *)
    And[Depth[?`s] > 3,		(* Test symbol definition table *)
      With[{`def = List@@Hold/@First[Hold@@[?`s, {1}]]},
	Or@@Map[With[{`op = #[[1, 0]],
	  `left = First[Hold/@First[Hold@@[#, {1}]]]},
	  And[`op === SetDelayed, Depth[`left] > 2,
	    Extract[`left, {1, 0}, Hold] === Hold[`s]]]&, `def]],
      Null[]]],

  _,		False];

Protect[BoundQ$, MemberBoundQ$, BoundQ, FBoundQ];

(* TkinterQ: Is Tkinter or KBMainFrame loaded? *)
TkinterQ[] := BoundQ[ReturnToSAD];
Protect[TkinterQ];

(* Protected constant symbol definitions *)
Scan[With[{sym = #}, SetAttributes[sym, Constant]; Protect[sym]]&, {
  ExpansionRatio, InitialSimplex, MaxIteration, MinimumSize,
  OptimizeFunction, Output, Persistence, SimplexSize, Threshold, Tolerance,
  Cutoff,
  Null[]}];

(* Unprotected constant symbol definitions *)
Scan[With[{sym = #}, SetAttributes[sym, Constant]]&, {
  Null[]}];

With[{`temporaryname = If[FBoundQ$[TemporaryName], Null[], TemporaryName]},
AutoLoad[EscapeShellMetaCharacter,
  FileNames, DirectoryName, ToFileName,
  $HomeDirectory,
  CreateDirectory, DeleteDirectory, RenameDirectory, CopyDirectory,
  CopyFile, RenameFile, DeleteFile, SetFileDate,
  FileDate, FileType, FileByteCount,
  FileQ, DirectoryQ,
  `temporaryname,	(* TemporaryName backward compatibility[insecure/not recommended] *)
  PackagesDirectory//"FileSystem.n"]];

AutoLoad[Class,This,Constructor,Destructor,Clone,Object,
  PackagesDirectory//"Class.n"];

AutoLoad[NearlySameQ,FixedPoint,FixedPoinstList,FunctionDefinition,
  PackagesDirectory//"Misc.n"];

AutoLoad[CaOpen,CaRead,CaWrite,CaGet,CaPut,CaClose,
  PackagesDirectory//"CAManager.n"];
AutoLoad[CaMonitor,PackagesDirectory//"CaMonitor.n"];
AutoLoad[EPICSDB,PackagesDirectory//"CEPICSRecord.n"];

$DisplayFunction=Which[
  Check[System["which tdr >/dev/null 2>&1"] == 0, False],	TopDrawer,
  Environment["DISPLAY"]<=>"",					CanvasDrawer,
  True,								Identity];
AutoLoad[ListPlot,Show,Graphics,Rectangle,
  PackagesDirectory//"ListPlot.n"];
AutoLoad[Plot,FitPlot,ListContourPlot,ListDensityPlot,
  ColumnPlot,HistoPlot,PackagesDirectory//"Plots.n"];
AutoLoad[TopDrawer,
  PackagesDirectory//"TopDrawer.n"];
AutoLoad[OpticsPlot,LatticePlot,BeamPlot,OP$S2Position,
  PackagesDirectory//"OpticsPlot.n"];
AutoLoad[GeometryPlot,
  PackagesDirectory//"GeometryPlot.n"];

AutoLoadSet[TclEval,Tk$Echo,Tk$EchoValue,Tcl$Interp,
  Tk$FullVersion,Tk$Version,Tk$MajorVersion,Tk$MinorVersion,Tk$PatchLevel,
  $WindowingSystem,
  $FontSystem,$DefaultFont,$DefaultSansSerifFont,$DefaultSerifFont,
  $DefaultFixedFont,$DefaultTerminalFont,$DefaultSymbolFont,
  $DefaultFontWeight,$DefaultFontSlant,$DefaultFontSize,
  PackagesDirectory//"TkinterCore.n"];
AutoLoad[Button,Window,TextLabel,Entry,RadioButton,CheckButton,
  TextMessage,TextEditor,ListBox,ScrollBar,Menu,MenuEntry,MenuButton,
  OptionMenu,Image,BitmapImage,PhotoImage,ApplicationName,AppNames,
  ApplicationNames,Bell,Wish,TclReturn,
  Canvas,After,AfterIdle,TkSense,TkWait,Wish,Update,
  PackagesDirectory//"Tkinter.n"];
AutoLoad[TkPhotoPutBlock,
  PackagesDirectory//"TkPhoto.n"];
AutoLoadSet[CanvasDrawer,Canvas$Widget,PackagesDirectory//"Canvas.n"];
AutoLoad[KBMainFrame,KBF$ConfDir,PackagesDirectory//"KBMainFrame.n"];
AutoLoad[KBFFileSelectionPanel,PackagesDirectory//"KBFFileSelectionPanel.n"];
AutoLoad[KBFTabFrame,KBFToggleFrame,PackagesDirectory//"TabFrame.n"];
AutoLoad[KBFOpenDialog,KBFSaveDialog,KBF$ListFiles,PackagesDirectory//"FileDialog.n"];
AutoLoad[KBFOptionDialog,KBFMessageBox,PackagesDirectory//"OptionDialog.n"];
AutoLoad[KBFrame,PackagesDirectory//"KBFrame.n"];
AutoLoad[KBDigitalIndicator,PackagesDirectory//"EPICSComponents1.n"];
AutoLoad[CaBinaryIndicator,PackagesDirectory//"CaBinaryIndicator.n"];
AutoLoad[CheckEntryList,PackagesDirectory//"CheckEntryList.n"];
AutoLoad[CursorEntry,CaCursorEntry,PackagesDirectory//"CursorEntry.n"];
AutoLoad[SI$StartInspect,PackagesDirectory//"SADInspect.n"];

AutoLoad[Fit,PolynomialFit,PackagesDirectory//"Fit.n"];
AutoLoad[help,HELP,Help,PackagesDirectory//"help.n"];
AutoLoad[Help$Messages,PackagesDirectory//"HelpMessages.n"];

AutoLoad[TableForm,PackagesDirectory//"tableform.n"];

AutoLoad[LinearSolve,Inverse,SingularValues,ConjugateTranspose,
  MatrixBalance,LinearSolveComplex1,LinearSolveComplex2,
  PackagesDirectory//"Matrix.n"];

AutoLoad[Emittance,SynchroBetaEmittance,SymplecticJ,SymplecticInverse,
  TouschekLifetime,TouschekF,
  BeamstrahlungUpsilon,BeamstrahlungNGamma,BeamstrahlungDeltaGamma,
  BeamstrahlungU0,BeamstrahlungU1,
  PackagesDirectory//"emit.n"];
AutoLoad[TransferMatrix,NormalCoordinates,BeamMatrix,
  GeoBase,OrbitGeo,
  PackagesDirectory//"Optics.n"];

AutoLoad[DynamicApertureSurvey,AccelerateParticles,
  PackagesDirectory//"dapert.n"];

AutoLoad[DownhillSimplex,Simplex,CalculateMatching,
  OptimizeOptics,PackagesDirectory//"optimize.n"];

AutoLoad[Monitor,Steer,
  ReadMonitorData,ReadSteerData,WriteMonitorData,WriteSteerData,
  PackagesDirectory//"correction.n"];

AutoLoad[BeamLine,PrintBeamLine,WriteBeamLine,
  PackagesDirectory//"beamline.n"];

AutoLoad[SetCoupledElements,CouplingMatrix,CoupledKeys,
  PackagesDirectory//"Couple.n"];

AutoLoad[D,Derivative,ReduceExpression,ReductionRule,Expand,
  Spline,SplineData,Integrate,NIntegrate,LegendreP,BesselJZero,
  PackagesDirectory//"D.n"];

AutoLoad[LDSolve,PackagesDirectory//"LDSolve.n"];

AutoLoad[TextTerminal,KBF$MakeSADTerminal,KBF$CloseSADTerminal,KBFSADTerminal,PackagesDirectory//"SADTerminal.n"];

AutoLoad[ProcessStatus,PackagesDirectory//"ProcessStatus.n"];

AutoLoad[Library,PackagesDirectory//"Library.n"];

AutoLoad[FFS$DRAW,FFS$GEO,FFS$TDR,PackagesDirectory//"FFSDRAW.n"];

AutoLoad[NISTACK$OBJ,NISTACK$FIXSEED,PackagesDirectory//"NISTACK.n"];

AutoLoad[TCPServer,PackagesDirectory//"NetworkIO.n"];

AutoLoad[Unicode2UTF8,AdobeSymbol2Unicode,AdobeSymbol2UTF8,PackagesDirectory//"Unicode.n"];

! End of File
